--Lugaru Cheat Engine Mod v1.2

--Welcome to the Lugaru Variable Playground mod! Though there's a lot you can do, you don't need to read all of it to get started.
--If you're unsure if you're going to like what this mod does, do not fear -- no Lugaru files are modified (though scores can be; read "IMPORTANT" in the "Getting Started" section). This mod is meant to run alongside Lugaru, changing the appropriate values in memory to make things happen. If you close Cheat Engine and restart Lugaru, it will run normally.

--You'll see a bunch of "--[[" and "]]" below; these are comment blocks. If a title of a block doesn't interest you, just look for a line with just a "]]" on it.
--For example, feel free to skip the "Explanation of Game Variables", and "Known Issues" sections; these are not essential to enjoying the mod.

--[[REQUIREMENTS
Default Lugaru game (the free demo and paid versions all work -- including the Steam version).
    -You can have mods that change things like textures or sounds so long as your "lugaru.exe" is the original.
Cheat Engine
Access to a the Function keys (F1 to F12) and the Numpad (for full controls). Don't have these? Check out the "Quick Modes" section.
]]

--[[GETTING STARTED
If you haven't connected Cheat Engine to Lugaru yet, here are the steps:

Installation:
-Install Cheat Engine
-If you have a "Lugaru.CT" file, put this in "My Documents\My Cheat Tables\", a folder created by Cheat Engine.
-If you just have this lua script, open up Cheat Engine, go to "Table", "Show Cheat Table Lua Script", and paste this entire script into the window that pops up. Now close the window and click "save", saving the file as "Lugaru.CT".

Running the Mod
-Start Cheat Engine and Lugaru
-Alt+Tab to Cheat Engine and select "Open Process", the icon with a flashing-red background (it can also be found in the "File" menu).
-From the list that pops up, choose the one with "Lugaru" in the name. It should be at or near the bottom of the list. Double-click it or select Open.
-Cheat Engine should now ask if you want to open up the "associated table", which should be "Lugaru.CT" - choose "yes".
-   If you do not get this message, you'll have to open up the Lugaru.CT file manually from whereever you stored it.
-Cheat Engine will now ask if you want to run the lua script with the file (which should be this script). Choose "yes".
-   If you choose "No", you can start the script later by going the "Show Cheat Table Lua Script" window and clicking "Execute".

IMPORTANT
Use a separate Lugaru profile while using this mod!
This mod modifies the in-game score shown at the top-left of the screen. Thus, it is recommended that you start a new profile to protect your high-scores, especially when experimenting! Although the mod resets its display to be the score Lugaru has given you, it is still very easy to inflate the score.
Note: The mod is still active (and listening for keystrokes) even if you've alt+tabbed out of Lugaru. Thus, for example, if you take a break from Lugaru (by alt+tabbing) to write some emails, and you happen to press any of the number keys or Function keys, the mod will activate the appropriate modes.

Testing the Mod
Go into a challenge level
Try pressing 0 (but not the Numpad 0) to give yourself invincibility, 6 (again, not the one on the Numpad) to make your enemies giants, or Ctrl+F2 to toggle "end of round wait time" -- the score will briefly show "299" or "290" to say the wait will be skipped or not skipped, respectively.

(If you want to use the campaign, read up on "Alt F2" and note that the score display won't work properly after the first level in which you get a score from combat).

WHAT NOW?
Try the Recommendations section (right below Basic Controls). If some of the terms don't make sense (like "damagetolerance"), look up "Explanation of Game Variables".
Below the Known Issues section is the detailed explanation and control list for all modes, starting with the Quick Modes and then going in numerical order (ie F2, then F3, etc).
]]

--[[BASIC CONTROLS
--Press keys 1-9 or 0 for a preset mode. You must use the numbers above the letters of your keyboard, not the numpad.
--Press an F key (ex F2) to set the mode and optionally use the Numpad keys to activate various options (differs for each mode).
---You must use the Numpad numbers, not the numbers above the letters on your keyboard

When you see something like this in the Mode List:
---Shift F2: Skip end-of-round wait time (press to activate).
This means "Hold down Shift, press F2, then release both". In this case, performing this action attempts to skip the "end of round wait time" (though it only works if you've already won the round).
You can activate this control at any time.
If you see "Ctrl F12, -, 0", hold down Control, press F12, then release both Control and F12. Then, on the numpad, press - and then 0.

--This script uses the in-game score value to give you information.
--  Not all commands modify the displayed score. The last mode that does is the one that will continue to do so. ex. Press "F10" for the timer, then "F4,0" for making everyone alive, the score will still be on "timer mode".

--If you've activated a whole bunch of modes and want to deactivate all the modes, follow these steps:
1. Go to Cheat Engine's "Show Cheat Table Lua Script" window and press "Execute".
2. Go to a new level (or restart the current one).
Note: if you've only been pressing keys 1-9 and 0 (not the numpad ones), you can just press "1" to reset them (though the "end of round wait time" is still skipped; press Ctrl F2 if you don't want it.).
Tip: Most modes offer a "reset" feature, which is usually activated by pressing "." on the numpad (but I highly recommend reading the details first).
]]

--[[RECOMMENDATIONS (sorted by the categories Utility, Training, Fun, Challenges, and Variable Modification)
Note: Everything mentioned in this section is covered in the Mode List.
UTILITY
Alt F2: Press this on campaign levels that have no combat to allow you to progress (otherwise the mod is still waiting for enemies to die).
Ctrl F2: Skip the end-of-round wait time of 7 seconds. This has no effect on high-score time, so you can safely use this on a "non-cheating" profile.
Ctrl F12, -, 0: Specify you want to see the damage of you and an enemy you are currently fighting with.

TRAINING
Shift F11: Start Endless Melee mode (everyone is automatically revived when knocked out/killed)
Ctrl F11, 2: Start Endless Duel mode with only one the first enemy in the duel with you! (Everyone else is "frozen", though they'll still move around - just very slowly)

FUN
Press 0 (not the numpad 0) for invincibility.
Alt F7, 1, /: Turn yourself into a Fire Monster (you will not be damaged by the fire)!
Alt F12, -, 1, -: Follow this up with 0,1,2,3, and/or 4 to enable the various toggles just for you. Enabling all of them gives you invincibility.
Alt F5, 1, then any of /,*,-: make your character sit/stand/sleep (if not engaged in combat)
Alt F6, 0, -: Give everyone a sword (only lasts this level)
Alt F6, 0, -, ., alt ., alt .: Give everyone a sword every level and force them to keep hold of it at all times (including through disarms!)
Alt F6, 1, ., shift - : (The "." is to keep changes) Give yourself an "infinitely throwable knife"! Whenever you drop, throw, or otherwise lose the knife, you immediately get a new one!
Alt F6, 1, ., shift * : Give yourself an unbreakable staff!
Alt F6, ., . (score will briefly show 651): Keep what you're carrying between levels. Whatever you end one level with (in terms of weapons), you'll start the next level with them!
F3, 1: Puts everyone's damagetolerance so low that all hits result in mists of blood.
F3, 2: Puts everyone's damagetolerance low enough that all hits result in a KO or death.

CHALLENGES AND OTHER MODES
Alt F12 followed by 0, 0: "superpermanentdamage" is decreased slowly for all characters
Alt F12 followed by 4, 4: bleeding damage is decreased slowly for all characters
Alt F12, 3: "To the Death": The "damage" variable for all characters will continue to decrease while unconcious (normally it only decreases while concious) - this means you must kill all your enemies to win! This also means that if you get knocked out (but not killed), you will be revived in a short time!
    Press Ctrl F12, 1, 9 to see your highest damage value; you should see it decreasing while unconcious, unless you died. Once it hits your damagetolerance value, you'll be awake again.
    NOTE: If you press the spacebar while unconcious, the level will reset!
F9: Lives mode (characters are revived while they have more than 1 life left; press a Numpad number to select the number of lives everyone gets)
Ctrl F5: A subtle challenge: the speed of enemies is continually and randomly changed (up to 15% faster or slower than your character)
Alt F5: Challenge mode! (Enemies always know where you are [though there are a few places you can hide sometimes])
6: A "quick mode" that cycles enemies being Giants, Midgets, or back to Normal. Both Giants and Midgets give a unique challenge!
You can combine most modes together! For example, combine Alt F5 with giving everyone swords (and forcing them to hang onto the swords) for a very difficult (but possible) challenge!
A harder challenge still would be Alt F5, everyone with swords (and everyone hangs onto them), and going up against Midgets.

VARIABLE MODIFICATION
F4, 0: Revive and heal everyone
Shift F4, 0: Kill everyone (9 for kill all enemies)
F5, 0, /: Reset all enemy AIs to passive
F3: Changes "damagetolerance"
Alt F3 (after using the F3 mode): The script remembers your changes to damagetolerance (see explanation below) between level (re)loads.
F6 and Shift F6 and Ctrl F6: Change various stats about a character (F6 is power, Shift F6 is scale, and Ctrl F6 is "speedmult" -- speed multiplier).

TIP: If you find yourself always activating the same mode(s), some "settings" (variables) are available (they are listed below the documentation for that mode in the Mode List section) -- change them at will! Just remember to save your changes (if you wish) and then restart the script (if you want to test it).
]]

--[[EXPLANATION OF GAME VARIABLES
--damagetolerance: Acts as health, armor, and weight, all in one. If a character is damaged by an amount that exceeds 50x this value, the character will splatter into a mist of blood (which you can see if you put damagetolerance to 10 or if you, for example, receive a ton of damage *and* get thrown into a wall that's right beside you [happened to me once without using any mods])
--damage: Starts at 0. Decreases at 13 per second to a minimum of permanentdamage. When this value hits damagetolerance, the character is knocked out. If a character receives 100 damage, this value increases by 100. If this value is greater than permanentdamage and the character is just standing still, the character will be bent over in pain.
--permanentdamage: Starts at 0. Decreases at about 4 per second (8 while idling or crouching) to a minimum of superpermanentdamage. If a character receives 100 damage, this value increases by 50. If this value reaches the character's damagetolerance, the character dies.
--superpermanentdamage: Starts at 0. Does not decrease. If a character receives 100 damage, this value increases by 25.
--bloodloss: Similar to "superpermanentdamage", but represents the amount of blood the character has lost. The character dies if this value exceeds damagetolerance while deathbleeding is greater than zero. Increases at a rate of 3*bleeding/sec + 80*deathbleeding/sec.
--deathbleeding: Increased by an amount depending on the weapon used (knife, sword, wolf slash), possibly from the 'bleeding' variable. This value returns to 0 quickly (1.6/sec). A value of 1 seems to increase bloodloss to around 25, 2 to 100, 3 to 225, and 4 to 425. Equals 1 while you're on fire and resets to 0 if you roll while on fire.
--bleeding: Increases based on weapon damage (and a bit of randomness).
]]

--[[KNOWN ISSUES:
-Freezing enemies (putting speedmult to 0) that aren't passive (aitype is 0) can really mess up the game (requiring Lugaru to completely restart). The script avoids doing this in duels, but you can still cause the issue by changing speedmult in Ctrl+F6 mode.
-INVINCIBILITY_TIME is required because without it, characters have been known to die twice in a row (possibly due to bleeding being increased over time?), especially when slaying with a knife or sword. Nonetheless, feel free to make it smaller or even 0.
THE FOLLOWING might be fixable
-If an enemy is dead for a significant amount of time (>1sec), they may be stuck on the ground even after reviving them.
-   If you can attack them in some way (ex. crouch-kick), they may get up. Usually you have to do this while they are dead, then revive them before they stop moving. If you can slay them while duel mode is on, this seems to work as well.
-The score display doesn't work properly when a campaign level loads with a non-zero score because the game displays the score as "campaignScore + currentScore"
LIMITATIONS:
-This script doesn't freeze the game while reading/writing values, so some changes in value (like game score) might theoretically get lost/overwritten if the script is also reading and writing to that same variable.
-This script does not support more than 8 characters on any one level (ie 7 enemies and yourself); Lugaru theoretically supports 10, though to my knowledge the default campaign/challenges use no more than 8, except for one level where there are 9 characters total (but no combat).
-Invincibility and damage-prevention modes cannot recover your character if you are hit so hard you turn into a mist of blood.
-If you press F12, you get "hits received/dealt" mode. This count is not guaranteed to be accurate since it determines the number of hits by the number of superpermanentdamage increases, and this increases several times by small values when you fall down. To resolve this, increases below MIN_DAMAGE_FOR_HIT (10) are ignored, which may ignore legitimate low-damage hits (ex enemy hits onto you if you've put your damagetolerance really high).
-The score display cannot reliably show more than 7 digits. A couple modes will alternate showing 7 digits and 1 digit if it's trying to show you "a digit per character".
]]

--MODE LIST AND SETTINGS
--Any variables in this section can be modified to change the default behaviour. You will receive a message in the Output window if you modify something incorrectly.
--Don't forget that modifying these values doesn't do anything until you (re)run the script.
--Anything after a double-dash or between a --[[ and a ]] is a comment.

BUG_FIXES = true --allow this mod to attempt to fix ghost weapons (you or a character using an invisible weapon; I think it happens while disarming gets interrupted)
SIMPLE_MODES = true --if true, modes that use numbers 1-9 and 0 above the main keyboard will operate

--The next two variables are not currently in use; they were part of a failed attempt at fixing the "die while disarming and fly into oblivion" bug.
--MAX_COORD_DIST = 200 --max allowed positional change before resetting character's position and velocity
--MAX_VELOCITY = 1000 --max allowed velocity before resetting character's position and velocity

UPDATE_FREQ = 100 --how frequently the script should update values in milliseconds. Minimum value is 1. Actual frequency may be up to 10ms more than this value.
--Changing UPDATE_FREQ to a lower value might improve this mod's responsiveness, but could also theoretically slow down Lugaru a bit. Increasing the value should be unnecessary.

--[[QUICK MODES
(All turn on the "skip-end-of-round-waiting-time" mode)
1: Reset modes 2-9 and 0
2: Damage tolerance and power equalizer (to yours)
3: 9 Lives mode (with damage-carry-over to future levels) -- how far can you get?
4: Enemies get an extra life (you get none)
5: Challenge mode (AIs know where you are)
6: Cycle through Giants mode (Enemy's are larger and more powerful, but slower) and Midgets mode (Enemy's are smaller and faster, but less powerful)
7: Endless Melee mode
8: Endless Duel mode (only 1 opponent)
9: Everyone gets a sword and is forced to hang on to it
0: You become invincible
]]
--If you want to alter the Giant or Midget Settings, search for "MakeEnemiesGiants()" (Midgets is right below it). You can see the available variables being modified by multiplying or adding a value. I recommend backing up the default values somewhere, but otherwise feel free to change them.
--[[ex. Maybe the Giants aren't big enough? Change:
writeFloat(RProp(i, scale), initialScale[i] * 1.5)
--to
writeFloat(RProp(i, scale), initialScale[i] * 3)
]]

--MODE LIST

--F1: reserved for Cheat Engine's help

--F2: show game score
-- .: Reset game score (only works after pressing F2)
--- *:Turn end-of-round auto-show-game-score on (default). /: Turn it off.
---Shift F2: Skip end-of-round wait time (press to activate).
---Ctrl F2: Toggle end-of-round wait time (default is to not change it).
--  Score will display 299 for skipping it and 290 for regular waiting.
--  Note that skipping the end-of-round wait time does not make the high-score time lower than it should be.
---Alt F2: Register that the current level you are on is a campaign level with no combat. Using this lets you move on to the next level (if you don't activate this control, the game will not advance to the next level).
SKIP_END_OF_ROUND_WAIT_TIME = false --allowed values: false or true
AUTO_SHOW_GAME_SCORE_AT_END = true --false or true

--F3: damagetolerance mode. Score will show damagetolerance, if possible (0 for reset). Min = 10 (all hits -> blood mist)
---Shift F3: Just enemies
---Ctrl F3: Just you
---Alt F3: Toggle saving changes between rounds. Will display 399 if changes are being saved, otherwise 390. Numpad keys have no effect after pressing Alt F3. Note that this feature ignores the fact that wolves have a higher damagetolerance and just blindly saves the current damagetolerance. Thus, it's best used when you set a specific damage tolerance, not a relative one.
--- .:Reset 1:10 2:50 3:100 4:150 5:200 6:250 7:300 8:350 9:400 /:500 *:1000 +/- increase/decrease by 50
--- Ctrl .: Toggle equalizing damagetolerance (enemies' damagetolerance increased to match yours). Will show 379 if on, else 370.
--- Alt .: Toggle "simulate hard mode" (your damagetolerance set to 200 and power set to 1). Note: Your armour bonus is *not* removed
---     (you get an armour bonus on the easiest difficulty level). Will show 359 if on, else 350. Once turned on, turning it off has no effect until the next level.
---NOTE: You can set a different damagetolerance for yourself and enemies. You must press Shift F3 to see enemy tolerance
--- or Ctrl F3 for yours: pressing F3 will show yours.
SIMULATE_HARD_MODE = false --if true, your damagetolerance will be decreased to 200 regardless of difficulty level. Also, your power will be set to 1.00 regardless of difficulty level.
EQUALIZE_DAMAGETOLERANCE = false --if true, enemy damagetolerance will be increased to match yours. Only matters if SIMULATE_HARD_MODE is false
--NOTE: The effect of the above two variables can be overwritten by manually specifying a damage tolerance or power through the F3 and F6 modes.

--F4: Make alive and reset damage
---Shift F4: Kill
---Ctrl F4: Reset damage (will not revive a dead enemy, but unconcious enemies will automatically be revived by the game)
---0:All 1:You 9:All enemies 2-8: Specific enemy *:random enemy +:dead/alive/injured enemies only (depending on mode)
---ex. "F4, +" will reset all *dead* characters to alive. "Shift F4, *" will kill a random enemy.
---     "Ctrl F4, 0" will reset everyone's damage
---NOTE: Pressing "Alt F4" will kill the program.

--F5: Change AItype. Display shows AItype if 7 or less selected, or else shows first 7.
---0:All enemies in duel or, if endless duel is not on, all enemies
---1:You 2-8:Specific enemy 9:All enemies
---/: passive *:aggressive -:gethelp +:getweapon control+:search for player .:reset to default
--- ex. To get everyone to attack you, press F5, 9, *.
---[Setting enemies AItype to "playercontrolled" does not let you control them, so it is not included.
--- Setting your own AItype can produce strange behaviour; making yourself aggressive causes you to attack yourself.]
--Shift F5: Change howactive
---0:All 1:You 2-8:Specific enemy 9:All enemies
---/:sitting *:normal -:sleeping .:reset all
---(Other values of howactive allow you to look like "injured Jack" or a put you into a variety of dead poses,
---  but you cannot get out of the animations by putting yourself back to "normal", so I've excluded them).
--Ctrl F5: Toggle Stats Challenge Modes (each control is a toggle)
---All characters's "speedmult" variable is continually changed (gradually and randomly) between 0.85 and 1.15.
--- .: Reset Stats Challenge Modes
--Alt F5: Toggle Challenge Mode!
---AIs are continually put into AIType 4 unless they are in AItypes 3, 4, 5, or 7.
---Numpad numbers have no effect if you have last pressed Alt F5.
STATS_CHALLENGE_MODE = false --if true, the enemy's speeds will be changed (Ctrl F5 will still toggle this on/off)
STATS_CHALLENGE_MAX_SPEED = 1.15 --must be a number greater than 0. 1 is the default speed, 2 would be double.
STATS_CHALLENGE_MIN_SPEED = 0.85 --also must be greater than 0
STATS_CHALLENGE_RATE_OF_CHANGE = 1 --how quickly the speed can change. Lower this to 0.25 and enemies will not change their speed so rapidly. Increase to 10 and they'll go between the min and max speeds every UPDATE_FREQ milliseconds. A value of 0 would prevent this mode from operating. A negative value is no different than a positive value.
STATS_CHALLENGE_INCLUDE_PLAYER = false --if true, your speed is also modified by this mode (but I found that this took out the challenge).

CHALLENGE_MODE_ON = false --if true, enemies will always know where you are by default (Alt F5 will still toggle it)

--F6: Change Power [Score will show the value * 100]
---Shift F6: Change Scale
---Ctrl F6: Change Speedmult
---Alt F6: Change weapon type
---Selection for all F6 modes:
---0:All 1:You 2-8:Specific enemy 9:All enemies
---For all but Alt F6:
---* or /:increase/decrease by 10 +/-:increase/decrease by 1
--- .: Toggle keeping changes between levels (will show 699 if they're being kept or 690 otherwise)
---For Alt F6:
--- /:knife *:staff -:sword +:nothing (will delete any equipped weapons)
--- shift *: invincible staff
--- shift +: deleted unequipped weapons
--- .: Cycle through the following "keep changes between levels" states:
---     Off (default): Score shows 650
---     Keep changes between levels: Score shows 659
---     "Keep What You're Carrying": Score shows 651 (consider disabling "skip end of round wait time" (Ctrl F2 toggles it) so you can pick up your weapons)
--- alt .: Toggle forced weapons: will keep weapon ownership the same (disarms become ineffective)
---     While active, you may not sheathe or drop a weapon.
---     If you have 2 weapons, you may switch between them.
---     Though you can throw a knife, it will come back to you within a fraction of a second. Use "Infinite Throwing Knives" instead.
---     Will show 629 if weapons are being forced for everyone, 621 for just you, 620 for no one.
--- Delete: Delete all weapons from the level (not permanent - simply use the above controls to recreate them).
--- control +: Reset all weapons to how they started at the beginning of the level.
EVERYONE_GETS_WEAPON = nil --valid values: nil (no change), 0 (no weapon), 1 (knife), 2 (staff), and 3 (sword)
EVERYONE_GETS_SPECIAL_WEAPON = false --true or false. True means you get an "infinite throwing knife" instead of a knife, or an unbreakable staff instead of a staff.
PLAYER_GETS_WEAPON = nil --same as EVERYONE_GETS_WEAPON, but what the player gets.
PLAYER_GETS_SPECIAL_WEAPON = false --
CHARACTERS_MUST_HANG_ON_TO_WEAPON = "off" --"off", "all", or "player". See "alt ." control above for effects.

--F7: Fire. For all F7 modes, score display will show a 1 or a 0 for each character (with the player first). ex, for 3 characters, if all are on fire except you, it will show "11". If only you are on fire of the 3 characters, it will show "100". For 8+ characters, it will only show the status of what you've selected (up to 7 characters).
---Shift F7: Fire Bomb (on unconciousness/death, character catches on fire)
---Ctrl F7: Burnt
---Alt F7: Fireproof (fire will be put out ASAP and bloodloss damage will be mostly taken away)
---0:All 1:You 2-8:Specific enemy 9:All enemies *:random enemy +:turn on -:turn off
--- .:Reset all (all modes and characters)(will not put out fires)
---In Alt F7 mode: /:turn on "Fire Monster" mode for the selected character(s). Continually puts the character(s) on fire, but prevents fire damage.
---ex. Press "Ctrl F7", "0", "+" to make everyone burnt
FIRE_BOMB_MODE_ON = false --false or true
EVERYONE_FIREPROOF = false --false or true
PLAYER_FIRE_MONSTER = false --false or true

--Random Fire Mode. Score will show frequency control. Each sub-mode is exclusive (ie having "normal" mode on means "wakeup" and "nonpassive" are both off). The frequency controls are independent of which mode is on.
--F8: Turn on "normal" mode: Characters will randomly catch on fire.
---Shift F8: Turn on "wakeup" mode: The aitype of enemies on fire will be set to 3 if it was 0 until the fire is put out or the enemy dies (unfortunately the AI's first impulse is often to jump instead of roll)
---Ctrl F8: Turn on "nonpassive" mode: Only non-passive characters will light on fire, and the player cannot light on fire unless at least one AI is non-passive (and alive).
---Alt F8: Stop Random Fire Mode (same as pressing 0 on the numpad). Numpad keys will still change the options, but nothing will happen until you press F8, Shift F8, or Ctrl F8.
--- /:Prevent you from randomly catching on fire. *:Allow you to randomly catch on fire (the default)
--[[ 0-9: Frequency controls [Score displayed will be in these brackets]
0:never (ie mode is off, the default)           [0]
1:everyone's likely to catch fire every 60sec   [601 (60 for 60-sec and 1 for "everyone")]
2:everyone's likely to catch fire every 30sec   [301]
3:everyone's likely to catch fire every 20sec   [201]
4:everyone's likely to catch fire every 10sec   [101]
5:someone'll catch on fire every 60 sec         [600]
6:someone'll catch on fire every 30 sec         [300]
7:someone'll catch on fire every 10 sec         [100]
8:someone'll catch on fire every 5sec           [50]
9:someone'll catch on fire every second         [10]
ex. For 9, every second, a character will be chosen to catch on fire.
    For 4, every (10 divided by # of alive, choose-able characters) seconds, a character will be chosen to catch on fire
        That is, if there are only 2 characters (who are allowed to catch on fire), someone'll be on fire every 5 seconds
        until the character-count changes
--- +/-: increase/decrease catch-on-fire-period by 1
--- ex. Press 9, then + and someone'll catch on fire every 2 seconds instead of every 1.
--- .: Stop Random Fire Mode
]]
RANDOM_FIRE_MODE_ON = false --valid values: false, "normal", "wakeup", "nonpassive"
--ex for setting it to nonpassive:
--RANDOM_FIRE_MODE_ON = "nonpassive"
RANDOM_FIRE_MODE_PERIOD = 10 --any number > 0 will do
RANDOM_FIRE_MODE_PERIOD_IS_SOMEONE = true --true/false. If true, someone will catch fire every RANDOM_FIRE_MODE_PERIOD seconds instead of everyone.
--Note: The RANDOM_FIRE_MODE_PERIOD settings are only used if RANDOM_FIRE_MODE_ON is true.

--F9: Lives Mode (everyone gets multiple lives). Score will show # lives as explained below
---Shift F9: Just enemies get lives. Score will show the sum of all enemies' lives.
---Ctrl F9: Only you get lives. Score will show # of your lives left.
---Alt F9: Stop Lives Mode.
---1-9: Select # of lives per character [where "1 life" is the last one; ie it doesn't go down to 0]
---0:Signal that a new level has loaded and all enemy lives should be reset
--- /: Toggle damage carry-over: your damage and bloodloss levels will be retained over level (re)loads. If it's on, score will briefly show 599, otherwise 590.
--- *: Reset all lives and revive everyone
--- .: Stop Lives Mode
--NOTE: You can combine giving yourself lives and enemies lives,
--  ex. If you press Ctrl F9, 5, Shift F9, 2 You get 5 lives, everyone else gets 2.
--SCORE DISPLAY: When there are 7 characters or less on the level (most levels):
--  The score displayed will be the lives of each character appended to each other.
--  ex. If you have 3 lives left, another opponent has none, the next has 2, the score will say "302".
-- When there are 8 characters, the score display will alternate between showing your lives left and
--  the enemies' lives left.
LIVES_MODE_ON = false --false or true
YOUR_LIVES = 1 --any integer greater than or equal to 1. Only meaningful if LIVES_MODE_ON is true.
ENEMY_LIVES = 2 --any integer greater than or equal to 1. Only meaningful if LIVES_MODE_ON is true.

--F10: Timer mode. Score shows how many centiseconds have passed since you started.
---Shift F10: Start timer
---Ctrl F10: Stop timer. If timer is already stopped, reset it.
---Alt F10: Display Lugaru's level-time (automatically resets after every level load).
--- .: Reset timer's time to 0. 1-3: Select display-accuracy level (1: seconds, 2:deciseconds, 3:centiseconds)
--- ex. 1.234 will show as 123 as centiseconds, 12 as deciseconds, and 1 as seconds.

--F11: Endless Duel/Melee Mode. Score shows how many KOs you've dealt/received. The two values are separated by a 0 when possible.
--  In this mode, everyone is immediately revived whenever they die (and their health fully restored).
--  You can partially freeze enemies you don't want involved in the fight to "duel" with specific enemies.
--      Frozen enemies will be "burnt" (blackened, but not actually hurt) so you can differentiate.
--      NOTE: Freezing enemies that are trying to attack you tends to mess up the game. Thus, the script attempts to passify them before freezing them (by repeatedly setting aitype to "passivetype" (0)). If the character is near you, they might see you immediately, preventing the script from freezing them. Run away from the enemy to freeze them. The script doesn't give up trying to passify them.
---Shift F11: Start endless melee mode (same as duel, but everyone's put into the fight).
---Ctrl F11: Start endless duel mode with no one but you in the duel.
---Alt F11: Stop this mode (score will *not* be reset)
---0: Toggle all enemies (either deselect or select all)
---2-8: Toggle that enemy
---Changing whether enemies are in or out of a duel will cause the total number of enemies in the duel to be displayed for one second.
ENDLESS_MELEE_ON = false --if true, levels will start out in melee mode
ENDLESS_DUEL_ON = false --if true, levels will start out in duel mode with the first enemy in the duel

--F12: Show hits received/dealt.
--- .: Reset to 0. 1: Show hits dealt 2: Show hits received 3: (default) Show both as (dealt)0(received).
MIN_DAMAGE_FOR_HIT = 10 --minimum amount of superpermanentdamage required to count as a "hit" (for the hit counter in F12).
--Shift F12: Show damage received/dealt. Note that superpermanentdamage is only 25% of these values.
--- .: Reset to 0. 1: Show damage dealt 2: Show damage received 3: (default) Show both as (dealt)(received).
--Ctrl F12: Show current superpermanentdamage
---/: superpermanentdamage *:permanentdamage -:damage +:bloodloss .:tolerance
---9: highest damage value (whether damage or bloodloss)
---1-8:character whose damage to show (default is player)
---0:Show both you and the first enemy who is both alive and aggressive.
--Alt F12: Toggles (that apply to all characters by default)
---0: Keep superpermanentdamage at 0 [tap 0 again for alternate: Let superpermanentdamage decrease at 2hp/s]
---1: Keep permanentdamage at superpermanentdamage
---2: Keep damage at permanentdamage
---3: Let damage/permanentdamage decrease even while unconcious
---4: Keep bloodloss at 0 [tap 4 again for alternate: Let bloodloss decrease at 1/sec]
--- -:Toggle per-character-toggle mode. While in this mode, 1-8 select a specific character, or 0 selects everyone (the default). Press '-' again to exit this mode.
--- .: Reset all toggles to 0
---Note: Score display will be six 1s and 0s representing whether the toggle is on or off (and the sixth value can show 2 for its alternate mode). A 9 represents "mixed" values. Also, if only one character is selected, the character number will be shown as well (to the left of the six 1s and 0s).
--The following settings can be false or true. They apply to everyone unless it says otherwise.
HUMAN_INVINCIBLE = false --If true, you start out invincible
EVERYONE_INVINCIBLE = false
NO_SUPERPERMANENT_DAMAGE = false --superpermanent damage stays at 0
SUPERPERMANENT_DAMAGE_DECREASES = false
NO_PERMANENT_DAMAGE = false --If true, permanentdamage is kept at superpermanentdamage
NO_DAMAGE = false --If true, damage is kept at superpermanent damage.
UNCONCIOUS_DAMAGE_DECREASE = false --If true, damage decreases even while unconcious.
HUMAN_NO_BLOODLOSS = false --If true, you cannot lose blood (ex. from slicing attacks or fire).
NO_BLOODLOSS = false
BLOODLOSS_DECREASES = false

SUPERPERMANENT_DAMAGE_DECREASE_RATE = 1 --per second
BLOODLOSS_DECREASE_RATE = 2 --per second

INVINCIBILITY_TIME = 1 --the number of seconds after a character is revived that all the character's damage variables are kept at 0.

--END OF MODE LIST AND SETTINGS -- modify anything below this point at your own risk of the mod breaking (which might mess up Lugaru until you restart it, depending on what you change)

MAX_WEAPONINSTANCES = 20 --from Lugaru
--MEMORY MANIPULATION CODE (and addresses)
addresses={"02424a78","024e65b4","025a80f0","02669c2c","0272b768","027ed2a4","028aede0","0297091c"}
currentframe="8"
targetframe="c"
currentanimation="10"
targetanimation="14"
--See Constants.h for animation types. Some key ones: 1 (neutral standing), 32 (walking)
--4 "old____" ints here
howactive="28"
--float, 2c
--bool superruntoggle at 30. Changing it is futile as it is reset before use. Controls AI run behaviour (allows wolves to run on all fours on highest difficulty)
--3 ints here, 3c, 38, 34
currentoffset="40"
targetoffset="4c"
offset="58"
target="64"
transspeed="68"
--float transspeed here [68]
--realoldcoords here (not used by Lugaru) [74,70,6c]
oldcoords="78"
coords="84"
--originalcoords here (not used by Lugaru)
velocity="9c" --a0, a4.
--4 XYZ proportions here
heightleft="d8"
heightright="dc"
unconscioustime="e0"
immobile="e4" --byte
velspeed="e8"

rabbitkickenabled="120" --not used
bloodloss="124"
deathbleeding="134"
damagetolerance="13c"
damage="140"
permanentdamage="144"
superpermanentdamage="148"
dead="150"

jumppower="154"
onground="158"
madskills="15c"
wentforweapon="160"
--2 bools at 164
facing="168" --an XYZ, 3 values at 168,16c,170
bleeding="174"
direction="180" --has to do with bleeding
--5 floats at 184,188,18c,190,194
onterrain="198"
pause="199"
grabdelay="19c"
victim="1a0"
hasvictim="1a4"
--2 floats at 1a8,1ac
--18 bools start at 1b0 [18=5 values]1b4,1b8,1bc,1c0
--4 more values I don't care about: 1c4,1c8,1cc,1d0
aitype="1d4" --see Person.h for constants (look for "passivetype")
aitarget="1d8"
--2 more floats at 1dc,1e0
ally="1e4" --doesn't do anything as far as I can tell
--movetarget:1e8,1ec,1f0
--39? more values here
creature="290"
id="294"
--skeleton here
speed="c09ac"
scale="c09b0"
power="c09b4"
speedmult="c09b8"
--6 floats starting at c09bc
--3 booleans starting at c09d4
--numclothes="c09d8"
--A78's worth of clothing memory here
--landhard="c1454"
onfire="c1457" --bool
--onfireDelay=c1458
burnt="c145c" --float
--fireDuration=c1460
--flameDelay=c1464, updatestuffdelay=68,playerdetail=6c
numweapons="c1470"
weaponids="c1474"--an int array of size 4
weaponid = {"c1474", "c1478", "c147c", "c1480"} --note that there is room for 4 weapons, but Lugaru expects no more than 2 being held by a character (the other room is probably for 'stuck' weapons)
weaponactive="c1484"
weaponstuck="c1488"
weaponstuckwhere="c148c"
weaponwhere="c1490"

--Below, the "[]" signifies it's a pointer. Each of these arrays is an array of size 20.
levelweapondamage = "[8f2438]" --if damage >= 2 on a staff, it breaks
levelweaponvelocity = "[8f2498]" --note: is of struct XYZ
levelweapontipvelocity = "[8f24a8]"
levelweapontypes="[8f24b8]" --a pointer to an array of ints
levelweaponoldowner="[8f24c8]"
levelweaponowner="[8f24d8]"
levelweaponbloody="[8f24e8]"
levelweaponblooddrip="[8f24f8]"
levelweaponblooddripdelay="[8f2508]"
levelweapononfire="[8f251c]"
levelweaponfiredelay="[8f252c]"
levelweaponmissed="[8f2540]"
levelweaponmass="[8f2550]"
levelweapontipmass="[8f2560]"
levelweaponlength="[8f2570]"
levelweaponfreetime="[8f2580]"
levelweaponfirstfree="[8f2594]"
levelweaponphysics="[8f25a8]"
levelweapondrawhowmany="[8f25b8]"
levelweaponhitsomething="[8f25cc]"

KNIFE = 1 SWORD = 2 STAFF = 3 --weapon-types; also works as array indices
--weapontypeconsts = {1, 2, 3}
weaponlengthconsts = {0.25, 0.8, 1.5}
weaponmassconsts = {1, 1.5, 2}
weapontipmassconsts = {1.2, 1, 1}

--the oldowner array seems to be 2 variables after the types array ends; likewise 'owner' starts 2 variables after oldowner ends.
function DecToBase(IN,BASE) --from http://giderosmobile.com/forum/discussion/906/a-neat-function-inbuilt-into-lua
    local B,K,OUT,D=BASE or 10,"0123456789ABCDEFGHIJKLMNOPQRSTUVW",""
    while IN>0 do
        IN,D=math.floor(IN/B),math.mod(IN,B)+1
        OUT=string.sub(K,D,D)..OUT
    end
    if string.len(OUT) == 0 then return "0" end
    return OUT
end
weapondamage = {} weapontype = {} weaponoldowner = {} weaponowner = {}
weaponbloody = {} weapononfire = {} weaponmass = {} weapontipmass = {} weaponlength = {}
for i = 1, MAX_WEAPONINSTANCES do
    local ext = "+" .. DecToBase((i-1)*4, 16)
    local boolExt = "+" .. DecToBase(i-1, 16)
    weapondamage[i] = levelweapondamage .. ext
    --velocity (XYZ)
    --tipvelocity (XYZ)
    weapontype[i] = levelweapontypes .. ext
    weaponoldowner[i] = levelweaponoldowner .. ext
    weaponowner[i] = levelweaponowner .. ext
    weaponbloody[i] = levelweaponbloody .. ext --int (0, 1, or 2)
    --weaponblooddrip[i] = levelweaponblooddrip .. ext
    --blooddripdelay[i] = levelweaponblooddripdelay
    weapononfire[i] = levelweapononfire .. boolExt
    --firedelay
    --missed (bool)
    weaponmass[i] = levelweaponmass .. ext --float
    weapontipmass[i] = levelweapontipmass .. ext --float
    weaponlength[i] = levelweaponlength .. ext --float
    --freetime
    --firstfree (bool)
    --physics (bool)
    --drawhowmany (float, equals 0, 1, or 10. continually updated by Lugaru)
    --hitsomething (bool)
end
levelnumweapons="8f2430" --variables at 2bbcb6c and 2bbcbc4 mimic 8f2430

score = "00725620"
changedelay = "004bdb34"
numplayers = "0063e53c" --starts out as '1' in menus.
--[[Other addresses that contained the same value:
001717a4: rnd @ start
004bd9f0: 0 @ start
004bde4c: 0 @ start]]
gametime = "17a86c" --starts at 0; stops increasing while the game is paused/between levels
leveltime = "17a884" --starts at 0 and resets to 0 every time a new level is loaded; stops increasing while the game is paused/between levels

function RProp(rabbit, property) --"Rabbit Property"
    --if property == nil or addresses[rabbit] == nil then LogEvent(debug.traceback()) end
    return addresses[rabbit] .. "+" .. property
end
function readXYZ(index, property)
    return {
        X=readFloat(RProp(index, property)),
        Y=readFloat(RProp(index, property .. "+4")),
        Z=readFloat(RProp(index, property .. "+8"))
    }
end
function writeXYZ(index, property, xyz)
    writeFloat(RProp(index, property), xyz.X)
    writeFloat(RProp(index, property .. "+4"), xyz.Y)
    writeFloat(RProp(index, property .. "+8"), xyz.Z)
end
function XYZToString(xyz)
    return "(" .. xyz.X .. ", " .. xyz.Y .. ", " .. xyz.Z .. ")"
end
function PlayerIsWolf(index)
    return readInteger(RProp(index, creature)) == 1
end
function SetProp(prop, value)
    for i = 1, #addresses do
        writeFloat(RProp(i, prop), value)
    end
end
function SetPropIf(prop, value, condition)
    for i = 1, #addresses do
        if condition(i) then
            writeFloat(RProp(i, prop), value)
        end
    end
end
function SetPropInt(prop, value)
    for i = 1, #addresses do
        writeInteger(RProp(i, prop), value)
    end
end
function SetPropIntIf(prop, value, condition)
    for i = 1, #addresses do
        if condition(i) then
           writeInteger(RProp(i, prop), value)
        end
    end
end
function SetPropByte(prop, value)
    for i = 1, #addresses do
        writeBytes(RProp(i, prop), value)
    end
end
function SetPropByteIf(prop, value, condition)
    for i = 1, #addresses do
        if condition(i) then
            writeBytes(RProp(i, prop), value)
        end
    end
end
function Show(prop)
    local msg = ""
    for i = 1, #addresses do
        msg = msg .. readFloat(RProp(i, prop)) .. " | "
    end
    showMessage(msg)
end
function ShowInt(prop)
    local msg = ""
    for i = 1, #addresses do
        msg = msg .. readInteger(RProp(i, prop)) .. " | "
    end
    showMessage(msg)
end
function GetArray(prop)
    local array = {}
    for i = 1, #addresses do
        array[i] = readFloat(RProp(i, prop))
    end
    return array
end
function SetArray(prop, array)
    for i = 1, #array do
        writeFloat(RProp(i, prop), array[i])
    end
end
function SetArrayIf(prop, array, condition)
    for i = 1, #array do
        if condition(i) then
            writeFloat(RProp(i, prop), array[i])
        end
    end
end
function SetArray2If(prop, value, condition)
    for i = 1, MAX_PLAYERS do
        if condition(i) then
            writeFloat(RProp(i, prop), value)
        end
    end
end
--END OF MEMORY MANIPULATION CODE

MAX_ENEMIES = #addresses - 1
MAX_SCORE_DIGITS = 7 --beyond this, the score value is not gauranteed to be accurate to the final digit, so don't create a number to display with more digits than this
MAX_PLAYERS = #addresses

function Round(a) return math.floor(a+0.5) end
function ArraysEqual(arr1, arr2)
    for i = 1, #arr1 do
        if arr1[i] ~= arr2[i] then return false end
    end
    return true
end
function CopyArray(source, dest)
    for i = 1, #source do dest[i] = source[i] end
end
function CopyArrayIf(source, dest, condition)
   for i = 1, #source do if condition(i) then dest[i] = source[i] end end
end
function InArray(element, array) --returns the 1-based index of "element" in "array" if it exists, or else 0
    for i = 1, #array do if array[i] == element then return i end end
    return 0
end
function Round3(x)
    return Round(x*1000) / 1000
end
function InArrayRound3(element, array)
    for i = 1, #array do if Round(array[i]*1000) == Round(element*1000) then return i end end
    return 0
end

function CallEvent(event, arg) --arg is optional; it should depend on the event
    for i = 1, #event do
        if event[i] then event[i](arg) end
    end
end
function SubscribeToEvent(event, func)
    table.insert(event, func)
end
function UnsubscribeFromEvent(event, func)
    local index = -1
    for i = 1, #event do
        if event[i] == func then index = i break end
    end
    if index == -1 then return end
    table.remove(event, index)
end

NewLevel = {} --event. Note that there may be up to one faulty "update" that gets called between level changes.
CharacterDied = {} --event with arg "character" (index, 1->8)
DropWeapon = {} --event that is called from SmartChangePlayerWeapon (with argument "weapon ID", which is 0-based). Used for infinite knives.

function floatIsFinite(f)
    return f == f and f > -math.huge and f < math.huge --f == f is false if f is NaN
end
function sensicalXYZ(xyz, oldXYZ)
    return xyz ~= nil and floatIsFinite(xyz.X) and floatIsFinite(xyz.Y) and floatIsFinite(xyz.Z)
end

function FixBugs()
    if gamePaused then return end
    --check if coords and oldcoords are very different or velocity is extreme
    --The following code doesn't fix the problem. Resetting velspeed, target, or offsets doesn't help either.
    -- for i = 1, numCharactersOnLevel do
    --     local xyz1 = readXYZ(i, oldcoords)
    --     local xyz2 = readXYZ(i, coords)
    --     local xyz3 = readXYZ(i, velocity)
    --     if math.abs(xyz1.X - xyz2.X) >= MAX_COORD_DIST or
    --             math.abs(xyz1.Y - xyz2.Y) >= MAX_COORD_DIST or
    --             math.abs(xyz1.Z - xyz2.Z) >= MAX_COORD_DIST or
    --             xyz3.X >= MAX_VELOCITY or xyz3.Y >= MAX_VELOCITY or xyz3.Z >= MAX_VELOCITY then
    --         --Character has skyrocketed
    --         writeXYZ(i, velocity, {X=0, Y=0, Z=0})
    --         writeXYZ(i, coords, xyz1)
    --     end
    -- end
    for i = 1, numCharactersOnLevel do --Check for ghost weapons
        if readInteger(RProp(i, numweapons)) == 0 and readInteger(RProp(i, weaponactive)) == 0 then
            writeInteger(RProp(i, weaponactive), -1)
        end
    end
end

function AssignWeaponProperties(weaponIndex, type) --weaponIndex 1 based
    writeInteger(weapontype[weaponIndex], type) --sets the type of the new weapon
    writeFloat(weaponlength[weaponIndex], weaponlengthconsts[type])
    writeFloat(weaponmass[weaponIndex], weaponmassconsts[type])
    writeFloat(weapontipmass[weaponIndex], weapontipmassconsts[type])
    writeFloat(weapondamage[weaponIndex], 0)
end
function MakeWeaponInactive(playerIndex) --call this if the player has precisely 1 weapon and you want to create an *active* weapon
    writeInteger(RProp(playerIndex, weaponid[2]), readInteger(RProp(playerIndex, weaponid[1])))
end
function CreateWeapon(ownerIndex, type, putIn0Slot) --putIn0Slot is optional (bool). Consider calling MakeWeaponInactive if putIn0Slot is true.
    --returns weapon index if successful, or else 0
    --ownerIndex is 0 based
    local pnum = readInteger(RProp(ownerIndex+1, numweapons))
    local num = readInteger(levelnumweapons)
    if num >= MAX_WEAPONINSTANCES then return 0 end
    AssignWeaponProperties(num+1, type)
    writeInteger(weaponoldowner[num+1], ownerIndex)
    writeInteger(weaponowner[num+1], ownerIndex)
    local index = pnum + 1
    if putIn0Slot then index = 1 end
    writeInteger(RProp(ownerIndex+1, weaponid[index]), num) --gives the player the new weapon
    writeInteger(RProp(ownerIndex+1, numweapons), math.min(2, pnum + 1))
    writeInteger(levelnumweapons, num + 1)
    return num+1
end
function ChangePlayerWeapon(playerIndex, type)
    --playerIndex is 0-based
    --Returns weapon index (1-based) if successful (meaning player now has 1+ weapons), or else 0
    --Changes the player's active (or otherwise first) weapon into the specified type.
    local pnum = readInteger(RProp(playerIndex + 1, numweapons))
    if pnum == 0 then return 0 end
    local active = readInteger(RProp(playerIndex + 1, weaponactive))
    local index --weapon index
    if active == -1 then
        index = readInteger(RProp(playerIndex + 1, weaponid[1])) + 1 --weapon indices are 1-based
        AssignWeaponProperties(index, type)
    else
        index = readInteger(RProp(playerIndex + 1, weaponid[active+1]))+1 --active+1 because weaponid is 1-based
        AssignWeaponProperties(index, type)
    end
    return index
end
oldestWeaponIndex = 1 --1 based. Represents the weapon to change, if possible.
SubscribeToEvent(NewLevel, function() oldestWeaponIndex = 1 end)
function SmartChangePlayerWeapon(playerIndex, type)
    --Returns weapon index (1-based) if successful (will return 0 (failed) if all 20 weapons are already in use)
    --playerIndex is 0-based
    --[[ Algorithm
    If player has 0 or 1 weapons:
        Create weapon and make it the active one
    If player has 2 weapons:
        Throw away the inactive weapon
        Create a new weapon
    (If at any time, you cannot create a weapon, hijack one instead.)
    (Make sure hijacking is possible or else return false immediately)
    ]]
    local index
    local num = readInteger(levelnumweapons)
    if num == MAX_WEAPONINSTANCES then --must make sure we have an ownerless weapon to hijack or else return now
        local successful = false
        for i = 1, MAX_WEAPONINSTANCES do
            local index = (oldestWeaponIndex + i - 2) % MAX_WEAPONINSTANCES + 1 --index is now from 1 to 20
            if readInteger(weaponowner[i]) == -1 then
                oldestWeaponIndex = index
                successful = true
                break
            end
        end
        if not successful then --only option is to change the weapon(s) the player already has (if any)
            return ChangePlayerWeapon(playerIndex, type)
        end
    end
    local pnum = readInteger(RProp(playerIndex + 1, numweapons))
    if pnum == 2 then --throw away inactive weapon (make ownerless)
        --weaponactive is always 0 (though it can be -1 if you have less than 2 weapons), which allows us to just select weaponid[2]
        writeInteger(RProp(playerIndex+1, numweapons), 1) --ensure the game doesn't change weaponid locations by saying player only has 1 weapon
        local theweaponid = readInteger(RProp(playerIndex + 1, weaponid[2]))
        writeInteger(weaponowner[1+theweaponid], -1)
        CallEvent(DropWeapon, theweaponid)
    end
    if pnum >= 1 then --put the weapon in slot #1 into slot #2 (will make it inactive if it was active)
        MakeWeaponInactive(playerIndex+1)
    end
    --Now we can safely put the new weapon in slot #1.
    index = CreateWeapon(playerIndex, type, true) --index is 1-based. 0 means failed
    if index ~= 0 then return index end
    --We must hijack a weapon and put it in slot #1
    for i = 1, math.min(readInteger(levelnumweapons), MAX_WEAPONINSTANCES) do
        index = (oldestWeaponIndex + i - 2) % MAX_WEAPONINSTANCES + 1 --index is now from 1 to 20
        if readInteger(weaponowner[index]) == -1 then
            --Give this weapon to the player
            AssignWeaponProperties(index, type)
            writeInteger(weaponoldowner[index], playerIndex)
            writeInteger(weaponowner[index], playerIndex)
            writeInteger(RProp(playerIndex + 1, weaponid[1]), index-1)
            writeInteger(RProp(playerIndex + 1, numweapons), math.min(2, pnum+1))
            oldestWeaponIndex = (index%MAX_WEAPONINSTANCES)+1
            return index
        end
    end
    return 0
end
function RemovePlayerWeapons(playerIndex)
    --playerIndex is 0 based
    for i = 1, MAX_WEAPONINSTANCES do
        if readInteger(weaponowner[i]) == playerIndex then
            writeInteger(weaponowner[i], -1)
        end
    end
    writeInteger(RProp(playerIndex + 1, numweapons), 0)
    writeInteger(RProp(playerIndex + 1, weaponactive), -1)
end
function DeletePlayerWeapons(playerIndex)
    local num = readInteger(levelnumweapons)
    for i = num, 1, -1 do
        if readInteger(weaponowner[i]) == playerIndex then
            ShiftWeaponsDown(i + 1, num)
            num = num - 1
            --Delete references to this weapon from the infiniteThrowingKnives lists
            for j = 1, #infiniteThrowingKnives do
                if infiniteThrowingKnives[j] == i - 1 then --a match
                    table.remove(infiniteThrowingKnives, j)
                    table.remove(infiniteThrowingKnivesOwner, j)
                end
            end
        end
    end
    writeInteger(levelnumweapons, num)
    writeInteger(RProp(playerIndex + 1, numweapons), 0)
    writeInteger(RProp(playerIndex + 1, weaponactive), -1)
end
function DeleteAllWeapons()
    writeInteger(levelnumweapons, 0)
    for i = 1, MAX_PLAYERS do
        writeInteger(RProp(i, numweapons), 0)
        writeInteger(RProp(i, weaponactive), -1)
    end
    for i = 1, MAX_WEAPONINSTANCES do
        writeInteger(weaponowner[i], -1)
    end
end
function ShiftWeaponsDown(startIndex, endIndex) --shift them down one in the array. startIndex MUST be greater than 1. Overwrites weapon @ startIndex-1.
    local floats = {weapondamage, weaponmass, weapontipmass, weaponlength}
    local ints = {weapontype, weaponoldowner, weaponowner, weaponbloody}
    local bools = {weapononfire}
    for i = startIndex, endIndex do --for each weapon that needs shifting down
        for j = 1, #floats do
            writeFloat(floats[j][i-1], readFloat(floats[j][i]))
        end
        for j = 1, #ints do
            writeInteger(ints[j][i-1], readInteger(ints[j][i]))
        end
        for j = 1, #bools do
            writeBytes(bools[j][i-1], readBytes(bools[j][i]))
        end
        --if any player owns this weapon, decrement the weapon ID reference
        for j = 1, numCharactersOnLevel do
            for k = 1, readInteger(RProp(j, numweapons)) do
                if readInteger(RProp(j, weaponid[k])) == i - 1 then --weaponid is 0-based, i is 1-based
                    writeInteger(RProp(j, weaponid[k]), i - 2)
                end
            end
        end
        --Other variables that refer to indices
        forceWeaponModeOwners[i - 1] = forceWeaponModeOwners[i]
        if #invincibleWeapon >= i then
            invincibleWeapon[i - 1] = invincibleWeapon[i]
        end
        for j = 1, #infiniteThrowingKnives do
            if infiniteThrowingKnives[j] == i - 1 then
                infiniteThrowingKnives[j] = i - 2
            end
        end
    end
end
function DeleteUnownedWeapons()
    local newnumweapons = readInteger(levelnumweapons)
    local curweaponindex = newnumweapons
    for i = newnumweapons, 1, -1 do
        if readInteger(weaponowner[i]) == -1 then --delete it
            if i < newnumweapons then
                ShiftWeaponsDown(i + 1, newnumweapons)
            end
            newnumweapons = newnumweapons - 1
        end
    end
    writeInteger(levelnumweapons, newnumweapons)
end

scriptStartTime = 0 --updated to "os.clock()" right before we start. Unit=seconds
gamePauseTime = 0 --the GameTime() at which the pause occurred
gamePaused = false
totalPauseTime = 0 --the total # of seconds the game has been paused
lastKnownGameTime = -1
function DealWithGamePausing()
    local curGameTime = readFloat(gametime)
    local newGamePaused = (curGameTime == lastKnownGameTime)
    lastKnownGameTime = curGameTime
    if gamePaused and not newGamePaused then --unpause
        gamePaused = false
        totalPauseTime = totalPauseTime + GameTime() - gamePauseTime
    elseif not gamePaused and newGamePaused then --pause
        gamePauseTime = GameTime()
        gamePaused = true
    end
end
function GameTime() --in seconds
    if gamePaused then
        return gamePauseTime
    else
        return os.clock() - scriptStartTime - totalPauseTime
    end
end

isEnemy = function(i) return i > 1 end
isDead = function(i) return readInteger(RProp(i, dead)) > 0 end
isPlayer = function(i) return i == 1 end
isInDuel = function(i) return inDuel[i] end
isNotInDuel = function(i) return not inDuel[i] end
isSelected = function(i) return selected[i] end

gameScore = readFloat(score)  --the game-score the player would have if we had never modified it
prevScore = nil --the previously displayed score
function SetScore(newScore)
    local curScore = readFloat(score) --currently displayed score
    if prevScore == nil then
        gameScore = curScore
    elseif curScore ~= prevScore then
        gameScore = gameScore + (curScore - prevScore)
    end
    writeFloat(score, newScore)
    prevScore = newScore
end
function ResetToGameScore()
    if prevScore ~= nil then
        writeFloat(score, gameScore)
        prevScore = nil
    end
end
function NumDigits(a) --works for positive numbers only
    if a == 0 then
        return 1
    elseif a < 0 then
        return math.floor(math.log10(-a)) + 2
    end
    return math.floor(math.log10(a)) + 1
end
function CombineScoreValues(a, b, numZeroesInBetween) --ex if a=53 and b=9, result is 539 (if numZeroes=1, it's 5309)
    return a*(10^(NumDigits(b)+numZeroesInBetween))+b
end

SubscribeToEvent(NewLevel, function()
    if prevScore ~= nil then SetScore(prevScore) end
end)

if timer == nil then timer = createTimer(nil) end
if UPDATE_FREQ < 1 then UPDATE_FREQ = 1 end
timer_setInterval(timer, UPDATE_FREQ)
timer_setEnabled(timer, false)


selected = {} --the characters that are currently selected
for i = 1, MAX_PLAYERS do selected[i] = false end
function SelectCharacters(indices)
    for i = 1, MAX_PLAYERS do selected[i] = false end
    for i = 1, #indices do selected[indices[i]] = true end
end
function SelectAll() SelectNone() for i = 1, numCharactersOnLevel do selected[i] = true end end
function SelectAbsolutelyAll() for i = 1, MAX_PLAYERS do selected[i] = true end end
function SelectPlayer() SelectCharacters({1}) end
function SelectEnemies() SelectNone() for i = 2, numCharactersOnLevel do selected[i] = true end end
function SelectAllEnemies() selected[1] = false for i = 2, MAX_PLAYERS do selected[i] = true end end
function SelectNone() for i = 1, MAX_PLAYERS do selected[i] = false end end
function NumSelected() local c = 0 for i = 1, #selected do if selected[i] then c = c + 1 end end return c end
function GetFirstSelected() for i = 1, #selected do if selected[i] then return i end end return nil end

if options ~= nil then
    for i = 1, #options do
        options[i].destroy()
    end
end
options = {} --list of option shortcuts
--Mode class
if Mode ~= nil and modes ~= nil then
    for i = 1, #modes do
        modes[i]:Destroy()
    end
end
Mode = {}
function Mode.new(Initialize, KeyPress, Update, GetDisplay, Destroy)
    --Note: All 5 arguments are functions. The first argument is "self". KeyPress has a 2nd argument, "key", which will always be a string of length 1.
    return setmetatable({
        hotkey=nil, --the hotkey object from createHotkey
        needsUpdate=false, --if true, Update will be called frequently
        Initialize=Initialize, --function responsible for creating hotkey. Note that Modes are responsible for setting "displayMode = self" if they want to be displayed when the hotkey runs.
        KeyPress=KeyPress, --will be called with numpad char that was pressed
        Update=Update, --will be called every UPDATE_FREQ milliseconds
        GetDisplay=GetDisplay, --the function to get the score-display value or "nil" if this mode doesn't display anything
        Destroy2=DestroyFunc --what to call (if non-nil) when the mode is being destroyed. Note it will be called in addition to Mode:Destroy.
    }, Mode)
end
Mode.__index = Mode
function Mode:Destroy()
    self.needsUpdate = false
    if self.hotkey ~= nil then self.hotkey.destroy() end
    if self.Destroy2 ~= nil then self.Destroy2() end
end

displayMode = nil --which mode is responsible for the score display
inputMode = nil --where to send non-mode keys
modes = {} --list of modes
function AddMode(mode)
    table.insert(modes, mode)
end
function CreateMode(Initialize, KeyPress, Update, GetDisplay, Destroy)
    local newMode = Mode.new(Initialize, KeyPress, Update, GetDisplay, Destroy)
    AddMode(newMode)
    return newMode
end
function bhf(self, func) --BaseHotkeyFunctionality wrapper
    return (function()
        inputMode = self
        if self.GetDisplay ~= nil then displayMode = self end
        if func ~= nil then func(self) end
    end)
end

--MODE CREATION STARTS HERE
--Modes are in order (F2s, F3s, etc)
autoResetToGameScore = AUTO_SHOW_GAME_SCORE_AT_END
skipEndOfRoundWait = SKIP_END_OF_ROUND_WAIT_TIME
skipEndOfRoundOnce = false
isCampaignNoCombatLevel = false
function GameScoreKeyPress(mode, key)
    if key == "*" then
        autoResetToGameScore = true
    elseif key == "/" then
        autoResetToGameScore = false
    end
end
showGameScoreMode = CreateMode( --F2: Show Game Score
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, ResetToGameScore), VK_F2) end,
    --[[KeyPress]]function(self, key)
        GameScoreKeyPress(self, key)
        if key=="." then
            gameScore = 0
            ResetToGameScore()
            writeFloat(score, 0)
        end
    end,
    --[[Update]]nil,
    --[[GetDisplay]] function(self) return nil end,
    --[[Destroy]]nil)
CreateMode( --Shift F2: Skip end-of-round wait time
    --[[Initialize]] function(self)
        SubscribeToEvent(NewLevel, function() skipEndOfRoundOnce = false end)
        self.hotkey = createHotkey(bhf(self, function()
            writeFloat(changedelay, 0)
            skipEndOfRoundOnce = true
        end), VK_SHIFT, VK_F2)
    end,
    --[[KeyPress]]GameScoreKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]nil,
    --[[Destroy]]nil)
CreateMode( --Ctrl F2: Toggle skipping end of round waiting time
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function()
        skipEndOfRoundWait = not skipEndOfRoundWait
    end), VK_CONTROL, VK_F2) end,
    --[[KeyPress]]GameScoreKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]function(self) return skipEndOfRoundWait and 299 or 290 end,
    --[[Destroy]]nil)
CreateMode( --Alt F2: Register no-combat campaign level
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function() isCampaignNoCombatLevel = true end), VK_MENU, VK_F2) end,
    --[[KeyPress]]GameScoreKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]nil,
    --[[Destroy]]nil)

initialDamageTolerance = {} --before we started modifying things. Lasts until another level is loaded (or the same one reloaded).
damageToleranceValues = {} --current damagetolerance set for each character. Interpret "nil"/empty as default.
simulatingHardMode = SIMULATE_HARD_MODE
equalizingDamageTolerance = EQUALIZE_DAMAGETOLERANCE
saveDamageToleranceChanges = false
saveDamageToleranceChangesTime = -1
equalizingDamageToleranceTime = -1
simulatingHardModeTime = -1
function damagetoleranceKeyPress(mode, key)
    if key == "." then --reset
        damageToleranceValues = {}
        if #initialDamageTolerance > 1 then
            SetArrayIf(damagetolerance, initialDamageTolerance, isSelected)
        end
    elseif key == "+" then
        if initialDamageTolerance[1] == nil then return end
        for i = 1, MAX_PLAYERS do
            if isSelected(i) then
                if damageToleranceValues[i] == nil then damageToleranceValues[i] = initialDamageTolerance[i] end
                damageToleranceValues[i] = damageToleranceValues[i] + 50
                if damageToleranceValues[i] >= 59 and damageToleranceValues[i] <= 61 then damageToleranceValues[i] = 50 end
                writeFloat(RProp(i, damagetolerance), damageToleranceValues[i])
            end
        end
    elseif key == "-" then
        if initialDamageTolerance[1] == nil then return end
        for i = 1, MAX_PLAYERS do
            if isSelected(i) then
                if damageToleranceValues[i] == nil then damageToleranceValues[i] = initialDamageTolerance[i] end
                damageToleranceValues[i] = damageToleranceValues[i] - 50
                if damageToleranceValues[i] < 10 then damageToleranceValues[i] = 10 end
                writeFloat(RProp(i, damagetolerance), damageToleranceValues[i])
            end
        end
    elseif key == "c." then
        equalizingDamageTolerance = not equalizingDamageTolerance
        equalizingDamageToleranceTime = GameTime() + 1
    elseif key == "a." then
        simulatingHardMode = not simulatingHardMode
        simulatingHardModeTime = GameTime() + 1
        if simulatingHardMode then
            writeFloat(RProp(1, damagetolerance), 200)
            writeFloat(RProp(1, power), 1.0)
        end
    else
        local value
        if key == "1" then
            value = 10
        elseif key == "2" then
            value = 50
        elseif key == "3" then
            value = 100
        elseif key == "4" then
            value = 150
        elseif key == "5" then
            value = 200
        elseif key == "6" then
            value = 250
        elseif key == "7" then
            value = 300
        elseif key == "8" then
            value = 350
        elseif key == "9" then
            value = 400
        elseif key == "/" then
            value = 500
        elseif key == "*" then
            value = 1000
        else
            return
        end
        SetArray2If(damagetolerance, value, isSelected)
    end
end
function damagetoleranceDisplay()
    --if everyone is selected:
    --  if all enemies are same: display Player, Enemy
    --  else ignore those that are on default and display what's left
    --      unless there's nothing left, in which case show Player, Enemy1
    --elseif player is selected: show player
    --else
    --  show enemy type 1, enemy type 2 (if type 2 is different)
    if saveDamageToleranceChangesTime >= GameTime() then return saveDamageToleranceChanges and 399 or 390 end
    if equalizingDamageToleranceTime >= GameTime() then return equalizingDamageTolerance and 379 or 370 end
    if simulatingHardModeTime >= GameTime() then return simulatingHardMode and 359 or 350 end
    local count = NumSelected()
    if count == 1 then --only the player is selected
        return readFloat(RProp(1, damagetolerance))
    end
    --if all enemies are the same, display Player, Enemy (but not Player if only enemies are selected)
    local allEnemiesSame = true
    local value = readFloat(RProp(2, damagetolerance))
    local value2 = -1
    for i = 3, numCharactersOnLevel do
        if readFloat(RProp(i, damagetolerance)) ~= value then
            value2 = readFloat(RProp(i, damagetolerance))
            allEnemiesSame = false
            break
        end
    end
    if allEnemiesSame then --display either Player, Enemy or just Enemy
        if count == MAX_PLAYERS then
            local playerValue = readFloat(RProp(1, damagetolerance))
            local numDigitsHere = NumDigits(playerValue) + NumDigits(value)
            if numDigitsHere >= MAX_SCORE_DIGITS then
                return playerValue
            else
                return CombineScoreValues(playerValue, value, 1)
            end
        else --only display enemies
            return value
        end
    elseif count == MAX_PLAYERS then
        local playerValue = readFloat(RProp(1, damagetolerance))
        local numDigitsHere = NumDigits(playerValue) + NumDigits(value)
        if numDigitsHere >= MAX_SCORE_DIGITS then
            return playerValue
        else
            return CombineScoreValues(playerValue, value, 1)
        end
    else --only show enemies. Enemy healths are dif. Show value and value2
        local numDigitsHere = NumDigits(value) + NumDigits(value2)
        if numDigitsHere >= MAX_SCORE_DIGITS then
            return value
        else
            return CombineScoreValues(value, value2, 1)
        end
    end
end
function DamageToleranceNewLevel()
    initialDamageTolerance = GetArray(damagetolerance)
    if simulatingHardMode then
        writeFloat(RProp(1, damagetolerance), 200)
        writeFloat(RProp(1, power), 1.0)
    elseif equalizingDamageTolerance then
        local increase = readFloat(RProp(1, damagetolerance)) - 200
        if increase > 0.1 then
            for i = 2, numCharactersOnLevel do
                writeFloat(RProp(i, damagetolerance), increase + readFloat(RProp(i, damagetolerance)))
            end
        end
    end
    if saveDamageToleranceChanges and #damageToleranceValues > 0 then
        SetArray(damagetolerance, damageToleranceValues)
    end
end
CreateMode( --F3: damagetolerance (all)
    --[[Initialize]] function(self)
        self.hotkey = createHotkey(bhf(self, SelectAll), VK_F3)
        SubscribeToEvent(NewLevel, DamageToleranceNewLevel)
    end,
    --[[KeyPress]]damagetoleranceKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]damagetoleranceDisplay,
    --[[Destroy]]nil)
CreateMode( --Shift F3: damagetolerance (enemies)
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, SelectEnemies), VK_SHIFT, VK_F3) end,
    --[[KeyPress]]damagetoleranceKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]damagetoleranceDisplay,
    --[[Destroy]]nil)
CreateMode( --Ctrl F3: damagetolerance (you)
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, SelectPlayer), VK_CONTROL, VK_F3) end,
    --[[KeyPress]]damagetoleranceKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]damagetoleranceDisplay,
    --[[Destroy]]nil)
CreateMode( --Alt F3: toggle saving damagetolerance changes
    --[[Initialize]] function(self)
        self.hotkey = createHotkey(bhf(self, function()
            saveDamageToleranceChanges = not saveDamageToleranceChanges
            saveDamageToleranceChangesTime = GameTime() + 1
        end), VK_MENU, VK_F3)
    end,
    --[[KeyPress]]damagetoleranceKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]damagetoleranceDisplay,
    --[[Destroy]]nil)

function MakeAlive(character) --index
    writeFloat(RProp(character, damage), 0)
    writeFloat(RProp(character, permanentdamage), 0)
    writeFloat(RProp(character, superpermanentdamage), 0)
    writeFloat(RProp(character, bloodloss), 0)
    writeFloat(RProp(character, deathbleeding), 0)
    writeFloat(RProp(character, bleeding), 0)
    writeInteger(RProp(character, dead), 0)
    InvincibilityRegisterRevival(character)
end
function Kill(character) --index
    writeFloat(RProp(character, damage), readFloat(RProp(character, damagetolerance))+100)
    writeFloat(RProp(character, permanentdamage), readFloat(RProp(character, damagetolerance))+1)
end
function ResetDamage(character) --index
    writeFloat(RProp(character, damage), 0)
    writeFloat(RProp(character, permanentdamage), 0)
    writeFloat(RProp(character, superpermanentdamage), 0)
    writeFloat(RProp(character, bloodloss), 0)
    writeFloat(RProp(character, deathbleeding), 0)
    writeFloat(RProp(character, bleeding), 0)
end

aliveResetMode = 0 --0 for alive/reset, 1 for kill, 2 for reset only
function AliveResetKeyPress(mode, key)
    if key == "0" then
        SelectAll()
    elseif key == "*" then --random enemy
        local validCharacters = {}
        for i = 2, numCharactersOnLevel do
            if not isDead(i) then
                table.insert(validCharacters, i)
            end
        end
        if #validCharacters == 0 then return end
        SelectCharacters({validCharacters[math.random(1,#validCharacters)]})
    elseif key == "+" then --all that make sense
        if aliveResetMode == 0 then
            for i = 1, numCharactersOnLevel do
                selected[i] = isDead(i)
            end
        elseif aliveResetMode == 2 then
            for i = 1, numCharactersOnLevel do
                selected[i] = not isDead(i)
            end
        else
            SelectAll()
        end
    else
        local num = tonumber(key)
        if num == nil then return end
        if num >= 1 and num <= 8 then
            SelectCharacters({num})
        elseif num == 9 then
            SelectEnemies()
        else
            return
        end
    end
    --Use the selection and aliveResetMode
    local func = nil
    if aliveResetMode == 0 then --alive & reset
        func = MakeAlive
    elseif aliveResetMode == 1 then --kill
        func = Kill
    else --reset dmg only
        func = ResetDamage
    end
    for i = 1, numCharactersOnLevel do
        if selected[i] then
            func(i)
        end
    end
end
CreateMode( --F4: Make alive and reset damage
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function() aliveResetMode = 0 end), VK_F4) end,
    --[[KeyPress]]AliveResetKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]nil,
    --[[Destroy]]nil)

CreateMode( --Shift F4: Kill
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function() aliveResetMode = 1 end), VK_SHIFT, VK_F4) end,
    --[[KeyPress]]AliveResetKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]nil,
    --[[Destroy]]nil)

CreateMode( --Ctrl F4: Reset damage
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function() aliveResetMode = 2 end), VK_CONTROL, VK_F4) end,
    --[[KeyPress]]AliveResetKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]nil,
    --[[Destroy]]nil)

CreateMode( --F5: Change AIType
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, nil), VK_F5) end,
    --[[KeyPress]]function(self, key)
        local value = nil
        if key == "." then --reset all
            writeInteger(RProp(1, aitype), 5)
            for i = 2, numCharactersOnLevel do
                writeInteger(RProp(i, aitype), 0)
            end
        elseif key == "0" then
            if duelOn then
                for i = 2, numCharactersOnLevel do
                    selected[i] = inDuel[i]
                end
            else
                SelectEnemies()
            end
        elseif key == "9" then
            SelectEnemies()
        elseif key == "/" then
            value = 0
        elseif key == "*" then
            value = 4
        elseif key == "-" then
            value = 6
        elseif key == "+" then
            value = 7
        elseif key == "c+" then
            value = 2
        else
            local num = tonumber(key)
            if not (num == nil or num < 1 or num > 8) then
                SelectCharacters({num})
            end
        end
        if value ~= nil then
            for i = 1, numCharactersOnLevel do
                if selected[i] then
                    writeInteger(RProp(i, aitype), value)
                end
            end
        end
    end,
    --[[Update]]nil,
    --[[GetDisplay]]function(mode)
        local num = 0
        local s = ""
        for i = 1, numCharactersOnLevel do
            if selected[i] then
                num = num + 1
                if num >= 8 then break end
                s = s .. tostring(readInteger(RProp(i, aitype)))
            end
        end
        return tonumber(s)
    end,
    --[[Destroy]]nil)

CreateMode( --Shift F5: Change howactive
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, nil), VK_SHIFT, VK_F5) end,
    --[[KeyPress]]function(self, key)
        local value = nil
        if key == "." then --reset all
            writeInteger(RProp(1, aitype), 5)
            for i = 1, numCharactersOnLevel do
                writeInteger(RProp(i, howactive), 0)
            end
        elseif key == "0" then
            SelectAll()
        elseif key == "9" then
            SelectEnemies()
        elseif key == "/" then --sitting
            value = 1
        elseif key == "*" then --normal
            value = 0
        elseif key == "-" then --sleeping
            value = 3
        else
            local num = tonumber(key)
            if not (num == nil or num < 1 or num > 8) then
                SelectCharacters({num})
            end
        end
        if value ~= nil then
            for i = 1, numCharactersOnLevel do
                if selected[i] then
                    writeInteger(RProp(i, aitype), value)
                end
            end
        end
    end,
    --[[Update]]nil,
    --[[GetDisplay]]function(mode)
        local num = 0
        local s = ""
        for i = 1, numCharactersOnLevel do
            if selected[i] then
                num = num + 1
                if num >= 8 then break end
                s = s .. tostring(readInteger(RProp(i, howactive)))
            end
        end
        return tonumber(s)
    end,
    --[[Destroy]]nil)

statsChallengeMode = STATS_CHALLENGE_MODE
if STATS_CHALLENGE_MAX_SPEED <= 0 then
    print("STATS_CHALLENGE_MAX_SPEED must be a number greater than 0.")
    statsChallengeMaxSpeed = 1.15
else
    statsChallengeMaxSpeed = STATS_CHALLENGE_MAX_SPEED
end
if STATS_CHALLENGE_MIN_SPEED <= 0 then
    print("STATS_CHALLENGE_MIN_SPEED must be a number greater than 0.")
    statsChallengeMinSpeed = 0.85
else
    statsChallengeMinSpeed = STATS_CHALLENGE_MIN_SPEED
end
if STATS_CHALLENGE_RATE_OF_CHANGE == 0 then
    print("STATS_CHALLENGE_RATE_OF_CHANGE should not be 0. Using default value of 1 instead.")
    statsChallengeRateOfChange = 1
else
    statsChallengeRateOfChange = STATS_CHALLENGE_RATE_OF_CHANGE
end
statsChallengeIncludePlayer = STATS_CHALLENGE_INCLUDE_PLAYER
CreateMode( --Ctrl F5: Stats Challenge Mode (speed)
    --[[Initialize]] function(self) self.needsUpdate = true self.hotkey = createHotkey(bhf(self, function() statsChallengeMode = not statsChallengeMode end), VK_CONTROL, VK_F5) end,
    --[[KeyPress]]function(self, key)
        if key == "." then --reset all
            statsChallengeMode = false
            for i = 1, numCharactersOnLevel do
                writeInteger(RProp(i, speedmult), 1)
            end
        end
    end,
    --[[Update]]function(self)
        if not statsChallengeMode then return end
        for i = (statsChallengeIncludePlayer and 1 or 2), numCharactersOnLevel do
            writeFloat(RProp(i, speedmult),
                math.min(statsChallengeMaxSpeed,
                    math.max(statsChallengeMinSpeed,
                        readFloat(RProp(i, speedmult))
                        + math.random(-100, 100)
                        * statsChallengeRateOfChange
                        / (10 * UPDATE_FREQ))))
        end
    end,
    --[[GetDisplay]]nil,
    --[[Destroy]]nil)

challengeMode = CHALLENGE_MODE_ON
CreateMode( --Alt F5: Toggle Challenge Mode! (aitype -> 4)
    --[[Initialize]] function(self) self.needsUpdate = true self.hotkey = createHotkey(bhf(self, function() challengeMode = not challengeMode end), VK_MENU, VK_F5) end,
    --[[KeyPress]]nil,
    --[[Update]]function()
        if not challengeMode then return end
        for i = 2, MAX_PLAYERS do
            local curType = readInteger(RProp(i, aitype))
            if not (curType == 3 or curType == 4 or curType == 5 or curType == 7) then
                writeInteger(RProp(i, aitype), 4)
            end
        end
    end,
    --[[GetDisplay]]nil,
    --[[Destroy]]nil)

variableModeType = power
keepVariableChanges = false
keepWeaponChanges = false --false, true, or "continue" for "what you have is what you keep"
lastPlayerWeapons = {} --table of up to 2 weapon types that the player was carrying
lastPlayerWeaponSpecials = {} --table of booleans (per weapon type the player is carrying)
newLastPlayerWeapons = {} --used to ignore the update right before a NewLevel occurs
newLastPlayerWeaponSpecials = {}
freezeLastPlayerWeapons = false --freeze on NewLevel until LevelTime is 0
variableShowToggle = -1
weaponShowToggle = -1
variableModeChanges = {} --table of tables. The second level of tables is [playerIndex] = relativeChange (and relativeChange is a cumulation of "inc", making it an *integer*, not a float.)
weaponModeChanges = {} --a list of weapon types for each player OR nil for "no change". It's length is the # of weapons on the level
weaponModeChangesSpecial = {} --a list of boolean paralleling weaponModeChanges. If true, the weapon has a special ability.
--Current special abilities: staff: invincibility, knife: infinite throw
initialWeaponSetup = {}
variableValues = {power, scale, speedmult}
expectedVariableDefaults = {
    {0.75, 1, 1.1111, 1.25}, --known starting values for power (varies based on difficulty) (wolves can also get 1.25)
    {0.18, 0.2, 0.23}, --known starting values for scale
    {1} --known starting values for speedmult
}
if CHARACTERS_MUST_HANG_ON_TO_WEAPON ~= "off" and CHARACTERS_MUST_HANG_ON_TO_WEAPON ~= "player" and CHARACTERS_MUST_HANG_ON_TO_WEAPON ~= "all" then
    print('CHARACTERS_MUST_HANG_ON_TO_WEAPON must be "off", "player", or "all".')
    forceWeaponMode = "off"
else
    forceWeaponMode = CHARACTERS_MUST_HANG_ON_TO_WEAPON
end
forceWeaponModeOwners = {} --owner ID for each weapon (so, forceWeaponModeOwners[1] is the owner ID for the weapon with ID 0), nil for "don't change"
forceWeaponModeNumWeapons = {} --numweapons for each player
forceWeaponModeWeapons = {} --list of weapon IDs (0-based) for each player. List is length forceWeaponModeNumWeapons.
weaponShowForceToggle = -1
invincibleWeapon = {} --for each weapon, "true" if it's invincible
invincibleWeaponsExist = false
infiniteThrowingKnives = {} --the weapon IDs of "infinite throwing knives" that are currently being held (ie haven't been thrown yet)
infiniteThrowingKnivesOwner = {} --the owner (1-based) for each throwing knife (parallels infiniteThrowingKnives); can be nil for "on ground"
SubscribeToEvent(DropWeapon, function(theweaponid) --drop an "infinite" knife
    for i = 1, #infiniteThrowingKnives do
        if infiniteThrowingKnives[i] == theweaponid then
            infiniteThrowingKnivesOwner[i] = nil
            return --should only be one reference in the list
        end
    end
end)
activeWeaponSetTime = {} --for forceWeaponMode, allows a user to not have a weapon active for up to ACTIVE_WEAPON_SET_TIME (for changing active weapons)
ACTIVE_WEAPON_SET_TIME = math.max(0.4, 2*UPDATE_FREQ/1000) --in seconds
function WeaponModeResetExtras()
    invincibleWeapon = {}
    invincibleWeaponsExist = false
    infiniteThrowingKnives = {}
    infiniteThrowingKnivesOwner = {}
end
if EVERYONE_GETS_WEAPON ~= nil then
    if EVERYONE_GETS_WEAPON < 0 or EVERYONE_GETS_WEAPON > 3 then
        print("EVERYONE_GETS_WEAPON must be nil or a number between 0 and 3")
    else
        keepWeaponChanges = true
        for i = 1, MAX_PLAYERS do
            weaponModeChanges[i] = {EVERYONE_GETS_WEAPON}
            if EVERYONE_GETS_WEAPON == KNIFE or EVERYONE_GETS_WEAPON == STAFF then weaponModeChangesSpecial[i] = EVERYONE_GETS_SPECIAL_WEAPON end
        end
    end
end
if PLAYER_GETS_WEAPON ~= nil then
    if PLAYER_GETS_WEAPON < 0 or PLAYER_GETS_WEAPON > 3 then
        print("PLAYER_GETS_WEAPON must be nil or a number between 0 and 3")
    else
        keepWeaponChanges = true
        weaponModeChanges[1] = {PLAYER_GETS_WEAPON}
        if PLAYER_GETS_WEAPON == KNIFE or PLAYER_GETS_WEAPON == STAFF then weaponModeChangesSpecial[1] = PLAYER_GETS_SPECIAL_WEAPON end
    end
end
function ResetVariableModeChanges()
    for value = 1, #variableValues do
        local v = variableValues[value]
        variableModeChanges[v] = {}
        for i = 1, MAX_PLAYERS do
            variableModeChanges[v][i] = 0
        end
    end
end
ResetVariableModeChanges()
function ApplyVariableModeChanges()
    for i = 1, #variableValues do
        for j = 1, #variableModeChanges[variableValues[i]] do
            local value = variableModeChanges[variableValues[i]][j]
            local curValue = readFloat(RProp(j, variableValues[i]))
            local valueIsDifferent = true --from default
            for k = 1, #expectedVariableDefaults[i] do
                if Round(curValue*1000) == Round(expectedVariableDefaults[i][k]*1000) then
                    valueIsDifferent = false
                    break
                end
            end
            if value ~= 0 and not valueIsDifferent then
                writeFloat(RProp(j, variableValues[i]), curValue + value/100)
            end --otherwise no change OR value hasn't been reset, so don't apply the change twice
        end
    end
end
function VariableModeKeyPress(mode, key)
    local inc = 0
    if key == "*" then
        inc = 10
    elseif key == "/" then
        inc = -10
    elseif key == "+" then
        inc = 1
    elseif key == "-" then
        inc = -1
    elseif key == "." then --toggle keeping changes between levels
        keepVariableChanges = not keepVariableChanges
        variableShowToggle = GameTime()
    elseif key == "0" then
        SelectAbsolutelyAll() --includes all possible indices; important for the variableModeChanges log.
        return
    elseif key == "9" then
        SelectAllEnemies() --includes all possible indices; important for the variableModeChanges log.
        return
    else
        local num = tonumber(key)
        if num == nil then return end
        if num >= 1 and num <= 8 then
            SelectCharacters({num})
        end
        return
    end
    --inc should be non-zero at this point
    for i = 1, MAX_PLAYERS do
        if selected[i] then
            writeFloat(RProp(i, variableModeType), readFloat(RProp(i, variableModeType)) + inc/100)
            variableModeChanges[variableModeType][i] = variableModeChanges[variableModeType][i] + inc
        end
    end
end
function VariableModeDisplay(mode)
    if variableShowToggle + 1 >= GameTime() then
        return keepVariableChanges and "699" or "690"
    end
    if NumSelected() == 0 then return 0 end
    return Round(readFloat(RProp(GetFirstSelected(), variableModeType)) * 100)
end
CreateMode( --F6: Change power
    --[[Initialize]] function(self)
        self.hotkey = createHotkey(bhf(self, function() variableModeType = power end), VK_F6)
        SubscribeToEvent(NewLevel, function()
            if keepVariableChanges then
                ApplyVariableModeChanges()
            else
                ResetVariableModeChanges()
            end
        end)
    end,
    --[[KeyPress]]VariableModeKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]VariableModeDisplay,
    --[[Destroy]]nil)
CreateMode( --Shift F6: Change scale
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function() variableModeType = scale end), VK_SHIFT, VK_F6) end,
    --[[KeyPress]]VariableModeKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]VariableModeDisplay,
    --[[Destroy]]nil)
CreateMode( --Ctrl F6: Change speedmult
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function() variableModeType = speedmult end), VK_CONTROL, VK_F6) end,
    --[[KeyPress]]VariableModeKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]VariableModeDisplay,
    --[[Destroy]]nil)
function InitializeForcedWeapons()
    forceWeaponModeOwners = {}
    forceWeaponModeNumWeapons = {}
    forceWeaponModeWeapons = {}
    for i = 1, readInteger(levelnumweapons) do
        forceWeaponModeOwners[i] = readInteger(weaponowner[i])
    end
    for i = 1, numCharactersOnLevel do
        forceWeaponModeNumWeapons[i] = readInteger(RProp(i, numweapons))
        forceWeaponModeWeapons[i] = {}
        for j = 1, forceWeaponModeNumWeapons[i] do
            forceWeaponModeWeapons[i][j] = readInteger(RProp(i, weaponid[j]))
        end
    end
end
function IsDeadStaff(weaponIndex)
    return readInteger(weapontype[weaponIndex]) == STAFF and readFloat(weapondamage[weaponIndex]) >= 2
end
function ResetToInitialWeapons() --Resets all weapons and recorded weapon changes
    if initialWeaponSetup == nil then return end
    DeleteAllWeapons()
    for i = 1, numCharactersOnLevel do
        for j = 1, #initialWeaponSetup[i] do
            SmartChangePlayerWeapon(i - 1, initialWeaponSetup[i][j])
        end
    end
    weaponModeChanges = {}
    weaponModeChangesSpecial = {}
    WeaponModeResetExtras()
end
CreateMode( --Alt F6: Change weapon
    --[[Initialize]] function(self)
        self.needsUpdate = true
        self.hotkey = createHotkey(bhf(self, function() variableModeType = speedmult end), VK_MENU, VK_F6)
        SubscribeToEvent(NewLevel, function()
            initialWeaponSetup = {}
            WeaponModeResetExtras()
            for i = 1, numCharactersOnLevel do
                initialWeaponSetup[i] = {}
                for j = 1, readInteger(RProp(i, numweapons)) do
                    initialWeaponSetup[i][j] = readInteger(weapontype[1+readInteger(RProp(i, weaponid[j]))])
                end
            end
            if keepWeaponChanges == true then
                --if all characters have a specific weapon (even if that weapon is 0), delete all weapons first
                local deleteOkay = true
                for i = 1, numCharactersOnLevel do
                    if weaponModeChanges[i] == nil then
                        deleteOkay = false
                        break
                    end
                end
                if deleteOkay then DeleteAllWeapons() end
                for i = 1, numCharactersOnLevel do
                    if weaponModeChanges[i] ~= nil then
                        RemovePlayerWeapons(i-1)
                        for j = #weaponModeChanges[i], 1, -1 do
                            local weaponIndex = SmartChangePlayerWeapon(i-1, weaponModeChanges[i][j])
                            if weaponIndex ~= 0 and weaponModeChangesSpecial[i][j] then
                                if weaponModeChanges[i][j] == KNIFE then
                                    local index = #infiniteThrowingKnives + 1
                                    infiniteThrowingKnives[index] = weaponIndex - 1
                                    infiniteThrowingKnivesOwner[index] = i --cannot use "table.insert" since this array has "nil holes"
                                else --invincible staff
                                    invincibleWeaponsExist = true
                                    invincibleWeapon[weaponIndex] = true
                                end
                            end
                        end
                    end
                end
                if not deleteOkay then DeleteUnownedWeapons() end
            else
                weaponModeChanges = {}
                weaponModeChangesSpecial = {}
                if keepWeaponChanges == "continue" then
                    RemovePlayerWeapons(0)
                    for j = #lastPlayerWeapons, 1, -1 do
                        local weaponIndex = SmartChangePlayerWeapon(0, lastPlayerWeapons[j])
                        if weaponIndex ~= 0 and lastPlayerWeaponSpecials[j] then
                            if lastPlayerWeapons[j] == KNIFE then
                                local index = #infiniteThrowingKnives + 1
                                infiniteThrowingKnives[index] = weaponIndex - 1
                                infiniteThrowingKnivesOwner[index] = i --cannot use "table.insert" since this array has "nil holes"
                            else --invincible staff
                                invincibleWeaponsExist = true
                                invincibleWeapon[weaponIndex] = true
                            end
                        end
                    end
                    DeleteUnownedWeapons()
                end
            end
            if forceWeaponMode ~= "off" then InitializeForcedWeapons() end
        end)
    end,
    --[[KeyPress]]function(self, key)
        local wepType = nil
        local makeInvincible = false
        local throwInfinite = false
        if key == "/" then
            wepType = KNIFE
        elseif key == "s/" then
            wepType = KNIFE
            throwInfinite = true
        elseif key == "*" then
            wepType = STAFF
        elseif key == "s*" then
            wepType = STAFF
            makeInvincible = true
        elseif key == "s+" then
            DeleteUnownedWeapons()
            if forceWeaponMode ~= "off" then InitializeForcedWeapons() end
            return
        elseif key == "-" then
            wepType = SWORD
        elseif key == "+" then
            wepType = 0 --no weapon
        elseif key == "c+" then
            ResetToInitialWeapons()
            return
        elseif key == "delete" then
            weaponModeChanges = {}
            weaponModeChangesSpecial = {}
            WeaponModeResetExtras()
            forceWeaponModeOwners = {}
            forceWeaponModeNumWeapons = {}
            forceWeaponModeWeapons = {}
            DeleteAllWeapons()
            return
        elseif key == "." then --toggle keeping changes between levels
            keepWeaponChanges = not keepWeaponChanges and true or keepWeaponChanges == true and "continue" or false
            if keepWeaponChanges == "continue" then freezeLastPlayerWeapons = false end
            weaponShowToggle = GameTime()
            return
        elseif key == "a." then
            forceWeaponMode = forceWeaponMode == "off" and "player" or forceWeaponMode == "player" and "all" or "off"
            weaponShowForceToggle = GameTime()
            if forceWeaponMode ~= "off" then
                InitializeForcedWeapons()
            end
            return
        elseif key == "0" then
            SelectAbsolutelyAll()
            return
        elseif key == "9" then
            SelectAllEnemies()
            return
        else
            local num = tonumber(key)
            if num == nil then return end
            if num >= 1 and num <= 8 then
                SelectCharacters({num})
            end
            return
        end
        for i = 1, MAX_PLAYERS do
            if selected[i] then
                if wepType == 0 then
                    DeletePlayerWeapons(i - 1)
                    weaponModeChanges[i] = nil
                    weaponModeChangesSpecial[i] = nil
                else
                    index = SmartChangePlayerWeapon(i - 1, wepType)
                    if index > 0 then --we have a new weapon
                        invincibleWeapon[index] = makeInvincible
                        if makeInvincible then invincibleWeaponsExist = true end
                        if throwInfinite then
                            local index2 = #infiniteThrowingKnives + 1
                            infiniteThrowingKnives[index2] = index - 1
                            infiniteThrowingKnivesOwner[index2] = i --cannot use "table.insert" since this array has "nil holes"
                        end
                        --Record weapon changes
                        weaponModeChanges[i] = {}
                        weaponModeChangesSpecial[i] = {}
                        for j = 1, readInteger(RProp(i, numweapons)) do
                            local weaponID = readInteger(RProp(i, weaponid[j]))
                            weaponModeChanges[i][j] = readInteger(weapontype[1+weaponID])
                            weaponModeChangesSpecial[i][j] = InArray(weaponID, infiniteThrowingKnives) ~= 0 or invincibleWeapon[weaponID+1]
                        end
                    end
                end
            end
        end
        if forceWeaponMode ~= "off" then InitializeForcedWeapons() end
    end,
    --[[Update]]function(self)
        if invincibleWeaponsExist then
            invincibleWeaponsExist = false
            local num = readInteger(levelnumweapons)
            for i = 1, num do
                if invincibleWeapon[i] then
                    invincibleWeaponsExist = true
                    writeFloat(weapondamage[i], 0)
                end
            end
        end
        if #infiniteThrowingKnives > 0 then
            for i = 1, #infiniteThrowingKnives do --Create replacements for dropped/thrown "infinite knives", unless they have no owner
                if infiniteThrowingKnivesOwner[i] ~= nil and readInteger(weaponowner[infiniteThrowingKnives[i]+1]) ~= infiniteThrowingKnivesOwner[i]-1 then --knife has been dropped or thrown
                    local oldID
                    if forceWeaponMode ~= "off" then
                        forceWeaponModeOwners[infiniteThrowingKnives[i] + 1] = nil
                        oldID = infiniteThrowingKnives[i]
                    end
                    infiniteThrowingKnives[i] = SmartChangePlayerWeapon(infiniteThrowingKnivesOwner[i] - 1, KNIFE) - 1
                    if forceWeaponMode ~= "off" then
                        forceWeaponModeOwners[infiniteThrowingKnives[i] + 1] = infiniteThrowingKnivesOwner[i] - 1
                        for j = 1, forceWeaponModeNumWeapons[infiniteThrowingKnivesOwner[i]] do
                            if forceWeaponModeWeapons[infiniteThrowingKnivesOwner[i]][j] == oldID then
                                forceWeaponModeWeapons[infiniteThrowingKnivesOwner[i]][j] = infiniteThrowingKnives[i]
                                break
                            end
                        end
                    end
                    writeInteger(RProp(infiniteThrowingKnivesOwner[i], weaponactive), 0)
                elseif infiniteThrowingKnivesOwner[i] == nil and readInteger(weaponowner[infiniteThrowingKnives[i]+1]) ~= -1 then --new owner!
                    infiniteThrowingKnivesOwner[i] = readInteger(weaponowner[infiniteThrowingKnives[i]+1]) + 1
                end
            end
        end
        if forceWeaponMode ~= "off" then
            --Note: If a character is dead, force him to hold any weapons he has (looks better than the weapon weirdly falling down).
            --Note: Ignore "dead" staffs
            for i = 1, readInteger(levelnumweapons) do --assign weapon owners
                if forceWeaponModeOwners[i] ~= nil and not IsDeadStaff(i) then
                    local newOwner = (forceWeaponModeOwners[i] == 0 or forceWeaponMode == "all") and forceWeaponModeOwners[i] or -1
                    writeInteger(weaponowner[i], newOwner)
                    if forceWeaponModeOwners[i] ~= nil then
                        writeInteger(weaponoldowner[i], forceWeaponModeOwners[i])
                    end
                end
            end
            dontSetActiveWeapon = isDead(1)
            if not dontSetActiveWeapon then
                local allDead = true
                for i = 2, numCharactersOnLevel do if not isDead(i) then allDead = false break end end
                if allDead then
                    dontSetActiveWeapon = true
                end
            end
            for i = 1, #forceWeaponModeNumWeapons do --for each player
                --if forceWeaponMode == "player" and i >= 2 then break end
                local deadStaffs = 0
                --If player has any dead staffs, don't include those in the "forceWeaponModeNumWeapons" count
                local index
                for j = 1, forceWeaponModeNumWeapons[i] do --for each player weapon slot
                    index = InArray(readInteger(RProp(i, weaponid[j])), forceWeaponModeWeapons[i])
                    if index ~= 0 and IsDeadStaff(index) then
                        deadStaffs = deadStaffs + 1
                    end
                end
                if forceWeaponMode == "all" or i == 1 then --continue normally
                    writeInteger(RProp(i, numweapons), forceWeaponModeNumWeapons[i] - deadStaffs)
                    if forceWeaponModeNumWeapons[i] > 0 then
                        local weaponFound = {} --true/false if that weapon/index found somewhere in the player's wep collection
                        for j = 1, forceWeaponModeNumWeapons[i] do --for each player weapon slot
                            index = InArray(readInteger(RProp(i, weaponid[j])), forceWeaponModeWeapons[i])
                            if index == 0 or weaponFound[index] or IsDeadStaff(index) then
                                --find a dif weapon to put in this slot
                                for k = 1, #forceWeaponModeWeapons[i] do
                                    if not IsDeadStaff(k) and not weaponFound[k] then --use this one
                                        writeInteger(RProp(i, weaponid[j]), forceWeaponModeWeapons[i][k])
                                        weaponFound[k] = true
                                        break
                                    end
                                end
                            else
                                weaponFound[index] = true
                            end
                        end
                    end
                    if forceWeaponModeNumWeapons[i] == deadStaffs then
                        writeInteger(RProp(i, weaponactive), -1)
                    elseif not dontSetActiveWeapon then
                        if forceWeaponModeNumWeapons[i] == 1 or isDead(i) then
                            writeInteger(RProp(i, weaponactive), 0)
                        else --delay setting the active weapon in case the player is changing weapons
                            if readInteger(RProp(i, numweapons)) > 0 then
                                if readInteger(RProp(i, weaponactive)) == -1 then
                                    if activeWeaponSetTime[i] == nil then
                                        activeWeaponSetTime[i] = GameTime() + ACTIVE_WEAPON_SET_TIME
                                    elseif GameTime() >= activeWeaponSetTime[i] then
                                        writeInteger(RProp(i, weaponactive), 0)
                                    end
                                else
                                    activeWeaponSetTime[i] = nil
                                end
                            end
                        end
                    elseif isDead(i) then
                        writeInteger(RProp(i, weaponactive), 0)
                    end
                else --this character isn't directly being affected by "force weapons". Take out any weapons they are holding but shouldn't (ex player weapons).
                    local num = math.min(2, readInteger(RProp(i, numweapons)))
                    for j = num, 1, -1 do
                        local weaponOwner = forceWeaponModeOwners[readInteger(RProp(i, weaponid[j]))+1]
                        if weaponOwner == 0 then --weapon belongs to the player; remove it
                            if j ~= num then --have to shift weapons down. Thanks to our assumption that num <= 2, this is easy:
                                writeInteger(RProp(i, weaponid[1]), readInteger(RProp(i, weaponid[2])))
                            end
                            num = num - 1
                            writeInteger(RProp(i, numweapons), num)
                        end
                    end
                end
            end
        end
        if freezeLastPlayerWeapons then
            local levelTime = readFloat(leveltime)
            if levelTime >= 0 and levelTime ~= freezeLastPlayerWeapons and Round3(levelTime) ~= Round3(freezeLastPlayerWeapons) then
                freezeLastPlayerWeapons = false
            end
        end
        if keepWeaponChanges == "continue" and not freezeLastPlayerWeapons then
            local num = readInteger(RProp(1, numweapons))
            lastPlayerWeapons = newLastPlayerWeapons
            lastPlayerWeaponSpecials = newLastPlayerWeaponSpecials
            newLastPlayerWeapons = {}
            newLastPlayerWeaponSpecials = {}
            for i = 1, num do
                local weaponID = readInteger(RProp(1, weaponid[i]))
                table.insert(newLastPlayerWeapons, readInteger(weapontype[1+weaponID]))
                local isSpecial = invincibleWeapon[weaponID+1] or InArray(weaponID, infiniteThrowingKnives) ~= 0
                table.insert(newLastPlayerWeaponSpecials, isSpecial)
            end
        end
    end,
    --[[GetDisplay]]function(self, key)
        if weaponShowToggle + 1 >= GameTime() and weaponShowToggle > weaponShowForceToggle then
            return keepWeaponChanges == "continue" and 651 or keepWeaponChanges and "659" or "650"
        elseif weaponShowForceToggle + 1 >= GameTime() then
            return forceWeaponMode == "all" and "629" or forceWeaponMode == "player" and "621" or "620"
        end
        local num = NumSelected()
        if num == 0 then return 0 end
        if num == 1 or (num > MAX_SCORE_DIGITS and numCharactersOnLevel > MAX_SCORE_DIGITS) then
            local i = GetFirstSelected()
            if readInteger(RProp(i, numweapons)) == 0 then
                return 0
            else
                local index = readInteger(RProp(i, weaponactive))
                if index == -1 then index = 1 else index = index + 1 --[[to make index 1-based]]end
                if not (index > 0 and index <= MAX_WEAPONINSTANCES) then return 0 end
                local id = readInteger(RProp(i, weaponid[index]))
                return readInteger(weapontype[id + 1])
            end
        else --display everyone's active (or 1st) weapon
            local s = ""
            for i = 1, numCharactersOnLevel do
                if selected[i] then
                    if readInteger(RProp(i, numweapons)) == 0 then
                        s = s .. "0"
                    else
                        local index = readInteger(RProp(i, weaponactive))
                        if index == -1 then index = 1 else index = index + 1 --[[to make index 1-based]]end
                        local id = readInteger(RProp(i, weaponid[index]))
                        if id <= 0 then id = 0 end
                        s = s .. tostring(readInteger(weapontype[1 + id]))
                    end
                end
            end
            return tonumber(s)
        end
    end,
    --[[Destroy]]nil)

fireBomb = {} --arrays of booleans (1 per player)
fireProof = {}
fireMonster = {} --note: fireMonster should not be on at the same time as fireProof
fireLastBloodloss = {} --array of floats (1 per player)
fireTypicalBloodloss = 82 --expected bloodloss from being on fire per second. Simple standing tests with manual reading of memory showed 77-81. Scripting tests showed 66-79 (but most being in the high seventies).
fireLastBloodlossGameTime = {} --array (per player), in seconds
fireBloodlossPenaltyAmount = {40, 9} --strangely, the algorithm cuts off ~ 40 dmg from knives and ~ 9 dmg from swords
fireBloodlossPenalty = {} --array of integer. 0 means "no penalty", 1 means "knife penalty", 2 means "sword penalty".
--Testing revealed that the current algorithm for "fire proof" and "fire monster" shave off 10-40 bloodloss damage from slicing attacks.
--The BloodlossPenalty is then given to any character whose bloodloss increases beyond normal fire-damage. The penalty is only given
--  after bloodloss increases from fire only.
SubscribeToEvent(NewLevel, function()
    for i = 1, MAX_PLAYERS do
        fireLastBloodloss[i] = 0
        fireLastBloodlossGameTime[i] = 0
        fireBloodlossPenalty[i] = 0
    end
end)
fireMode=onfire --either an address, 0 (fire bomb), or 1 (fireproof or fire monster)
if FIRE_BOMB_MODE_ON then
    for i = 1, MAX_PLAYERS do fireBomb[i] = true end
end
if EVERYONE_FIREPROOF then
    for i = 1, MAX_PLAYERS do fireProof[i] = true end
end
if PLAYER_FIRE_MONSTER then
    fireMonster[1] = true
    fireProof[1] = false
end
function FireKeyPress(mode, key) --for fire/burnt variable modifiers
    if key == "/" or key == "+" or key == "-" then
        local value = key == "+" and 1 or key == "-" and 0 or 2
        if fireMode == 0 then --fire bomb mode
            for i = 1, MAX_PLAYERS do
                if selected[i] then fireBomb[i] = value == 1 end
            end
        elseif fireMode == 1 then --fireproof mode
            for i = 1, MAX_PLAYERS do
                if selected[i] then
                    fireProof[i] = value == 1
                    fireMonster[i] = value == 2
                end
            end
        elseif fireMode == onfire then
            SetPropByteIf(onfire, value, isSelected)
        else --fireMode == burnt
            SetPropIf(burnt, value, isSelected)
        end
    elseif key == "*" then
        SelectCharacters({math.random(2, MAX_PLAYERS)})
    elseif key == "." then --reset all
        for i = 1, MAX_PLAYERS do
            fireBomb[i] = false
            fireProof[i] = false
            fireMonster[i] = false
        end
        SetProp(burnt, 0)
        SetPropByte(onfire, 0)
    elseif key == "0" then
        SelectAll()
    elseif key == "9" then
        SelectEnemies()
    else
        local num = tonumber(key)
        if num == nil then return end
        if num >= 1 and num <= 8 then
            SelectCharacters({num})
        end
    end
end
function FireDisplay(mode)
    local d = 1
    local total = 0
    local GetValue = nil
    if fireMode == 0 then
        GetValue = function(i) return fireBomb[i] and 1 or 0 end
    elseif fireMode == 1 then
        GetValue = function(i) return fireMonster[i] and 2 or fireProof[i] and 1 or 0 end
    elseif fireMode == onfire then --bool
        GetValue = function(i) return readBytes(RProp(i, onfire)) end
    else --fireMode == burnt, a float
        GetValue = function(i) return readFloat(RProp(i, burnt)) end
    end
    if numCharactersOnLevel <= MAX_SCORE_DIGITS then
        for i = numCharactersOnLevel, 1, -1 do
            total = total + GetValue(i) * d
            d = d * 10
        end
        return total
    else
        local s = ""
        for i = 1, MAX_PLAYERS do
            if selected[i] then
                s = tostring(GetValue(i)) .. s
                total = total + 1
                if total == MAX_SCORE_DIGITS then break end
            end
        end
        return tonumber(s)
    end
end
CreateMode( --F7: Fire
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function() fireMode=onfire end), VK_F7) end,
    --[[KeyPress]]FireKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]FireDisplay,
    --[[Destroy]]nil)
CreateMode( --Shift F7: Fire Bomb
    --[[Initialize]] function(self)
        self.hotkey = createHotkey(bhf(self, function() fireMode=0 end), VK_SHIFT, VK_F7)
        SubscribeToEvent(CharacterDied, function(i)
            if fireBomb[i] then
                writeBytes(RProp(i, onfire), 1)
            end
        end)
    end,
    --[[KeyPress]]FireKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]FireDisplay,
    --[[Destroy]]nil)
CreateMode( --Ctrl F7: Burnt
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function() fireMode=burnt end), VK_CONTROL, VK_F7) end,
    --[[KeyPress]]FireKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]FireDisplay,
    --[[Destroy]]nil)
CreateMode( --Alt F7: FireProof
    --[[Initialize]] function(self) self.needsUpdate = true self.hotkey = createHotkey(bhf(self, function() fireMode=1 end), VK_MENU, VK_F7) end,
    --[[KeyPress]]FireKeyPress,
    --[[Update]]function()
        --If someone is on fire and bloodloss difference is within "toleratableBloodloss", reset bloodloss
        --  else if it is greater than toleratableBloodloss, decrease by expectedBloodloss
        --If, after decreasing, someone becomes alive (ie bloodloss decreases below damagetolerance), revive them.
        for i = 1, numCharactersOnLevel do
            if (fireProof[i] and readBytes(RProp(i, onfire)) == 1) or fireMonster[i] then --reduce bloodloss
                --Note: The layout of this section has been designed to try to minimize error, assuming that Lugaru is changing these numbers even as we work with them
                if fireProof[i] then
                    writeBytes(RProp(i, onfire), 0)
                end
                --Objective: Reduce bloodloss from fire damage.
                --Read all relevant information from memory. It may become outdated as we progress.
                local curGameTime = GameTime()
                local bloodlossValue = readFloat(RProp(i, bloodloss))
                local bloodlossChange = bloodlossValue - fireLastBloodloss[i]
                if bloodlossChange > 0 then --don't mess with it if it's gone down
                    --Calculate what we want
                    local expectedBloodloss = fireTypicalBloodloss * (curGameTime - fireLastBloodlossGameTime[i])
                    local toleratableBloodloss = 1.2 * expectedBloodloss
                    local newBloodloss
                    if bloodlossChange < toleratableBloodloss then
                        newBloodloss = fireLastBloodloss[i]
                        if fireBloodlossPenalty[i] ~= 0 then
                            newBloodloss = newBloodloss + fireBloodlossPenaltyAmount[fireBloodlossPenalty[i]]
                            bloodlossChange = bloodlossChange - fireBloodlossPenaltyAmount[fireBloodlossPenalty[i]]
                        end
                        fireBloodlossPenalty[i] = 0
                    elseif bloodlossChange > expectedBloodloss * 2 then
                        fireBloodlossPenalty[i] = 2
                        newBloodloss = bloodlossValue
                    else
                        fireBloodlossPenalty[i] = math.max(fireBloodlossPenalty[i], 1)
                        newBloodloss = bloodlossValue
                    end

                    --Now, assign to memory
                    if fireProof[i] then writeFloat(RProp(i, deathbleeding), 0) end
                    writeFloat(RProp(i, bloodloss), newBloodloss)
                    --...and do some recording
                    fireLastBloodloss[i] = newBloodloss
                    fireLastBloodlossGameTime[i] = curGameTime --placing this line here means that we might be "generous" later on and take off more than we should
                    
                    --Finally, is the character dead, but shouldn't be? Revive.                
                    local damagetoleranceValue = readFloat(RProp(i, damagetolerance))
                    if bloodlossValue < damagetoleranceValue and bloodlossValue + bloodlossChange >= damagetoleranceValue then
                        if readFloat(RProp(i, damage)) < damagetoleranceValue then
                            writeInteger(RProp(i, dead), 0)
                        elseif readFloat(RProp(i, superpermanentdamage)) < damagetoleranceValue then
                            writeInteger(RProp(i, dead), 1)
                        end
                    end
                else --bloodloss has gone down
                    fireLastBloodloss[i] = bloodlossValue
                    fireLastBloodlossGameTime[i] = curGameTime
                end
                --One last thing: ignite fire monsters                
                if fireMonster[i] then
                    writeBytes(RProp(i, onfire), 1)
                end
            else
                fireLastBloodloss[i] = readFloat(RProp(i, bloodloss))
            end
        end
    end,
    --[[GetDisplay]]FireDisplay,
    --[[Destroy]]nil)

randomFireType = "off" --can also be normal, wakeup, or nonpassive
if RANDOM_FIRE_MODE_ON then
    if 0 == InArray(RANDOM_FIRE_MODE_ON, {"normal", "wakeup", "nonpassive"}) then
        print("RANDOM_FIRE_MODE_ON has an invalid value.")
    else
        randomFireType = RANDOM_FIRE_MODE_ON
    end
end
lastRandomFireTime = 0 --game time
randomFirePeriod = randomFireType ~= "off" and RANDOM_FIRE_MODE_PERIOD or 0
randomFirePeriodDivideByCharacters = not RANDOM_FIRE_MODE_PERIOD_IS_SOMEONE
randomFirePeriodArray = {60, 30, 20, 10, 60, 30, 10, 5, 1}
randomFirePeriodDivideByCharactersArray = {true, true, true, true, false, false, false, false, false}
randomFirePlayerValidTarget = true
randomFireAIIndex = {} --list of AIs set on fire that are still on fire and alive.
randomFireAIType = {} --the AI type of the AIs set on fire *before* we set it to 3
function RandomFireKeyPress(mode, key)
    if key == "/" then
        randomFirePlayerValidTarget = false
    elseif key == "*" then
        randomFirePlayerValidTarget = true
    elseif key == "0" then
        randomFirePeriod = 0
    elseif key == "+" then
        randomFirePeriod = randomFirePeriod + 1
    elseif key == "-" then
        randomFirePeriod = randomFirePeriod - 1
        if randomFirePeriod < 0 then randomFirePeriod = 0 end
    elseif key == "." then
        randomFireType = "off"
    else
        local num = tonumber(key)
        if num == nil then return end
        randomFirePeriod = randomFirePeriodArray[num]
        randomFirePeriodDivideByCharacters = randomFirePeriodDivideByCharactersArray[num]
    end
end
function RandomFireDisplay(mode)
    if randomFirePeriod == 0 then return "0" end
    return tostring(randomFirePeriod * 10 + (randomFirePeriodDivideByCharacters and 1 or 0))
end
CreateMode( --F8: Random Fire "Normal" Mode
    --[[Initialize]] function(self)
        self.needsUpdate = true
        self.hotkey = createHotkey(bhf(self, function() randomFireType = "normal" end), VK_F8)
    end,
    --[[KeyPress]]RandomFireKeyPress,
    --[[Update]]function()
        for i = #randomFireAIIndex, 1, -1 do --for "wakeup" mode
            if isDead(randomFireAIIndex[i]) or readBytes(RProp(randomFireAIIndex[i], onfire), 1) == 0 then
                writeInteger(RProp(randomFireAIIndex[i], aitype), randomFireAIType[i])
                table.remove(randomFireAIIndex, i)
                table.remove(randomFireAIType, i)
            end
        end
        if randomFireType == "off" or randomFirePeriod == 0 then return end
        local available = {} --indices of characters we can set on fire
        for i = 2, numCharactersOnLevel do
            if not isDead(i) and (randomFireType ~= "nonpassive" or readInteger(RProp(i, aitype)) > 1) then
                table.insert(available, i)
            end
        end
        if (randomFireType == "normal" or randomFireType == "wakeup" or #available > 0) and randomFirePlayerValidTarget then
            table.insert(available, 1)
        end
        if #available == 0 then return end
        local actualPeriod = randomFirePeriodDivideByCharacters and (randomFirePeriod / (#available)) or (randomFirePeriod)
        local now = GameTime()
        if now - lastRandomFireTime < actualPeriod then return end
        lastRandomFireTime = now
        local index = available[math.random(1, #available)]
        writeBytes(RProp(index, onfire), 1)
        if randomFireType == "wakeup" then
            local value = readInteger(RProp(index, aitype))
            if not (value == 3 or value == 4 or value == 5 or value == 7) then
                writeInteger(RProp(index, aitype), 4)
                table.insert(randomFireAIIndex, index)
                table.insert(randomFireAIType, value)
            end
        end
    end,
    --[[GetDisplay]]RandomFireDisplay,
    --[[Destroy]]function() randomFireType = "off" randomFirePeriod = 0 end)
CreateMode( --Shift F8: Random Fire "Wakeup" Mode
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function() randomFireType = "wakeup" end), VK_SHIFT, VK_F8) end,
    --[[KeyPress]]RandomFireKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]RandomFireDisplay,
    --[[Destroy]]nil)
CreateMode( --Ctrl F8: Random Fire "Nonpassive" Mode
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function() randomFireType = "nonpassive" end), VK_CONTROL, VK_F8) end,
    --[[KeyPress]]RandomFireKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]RandomFireDisplay,
    --[[Destroy]]nil)
CreateMode( --Alt F8: Turn off Random Fire Mode
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function() randomFireType = "off" end), VK_MENU, VK_F8) end,
    --[[KeyPress]]RandomFireKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]RandomFireDisplay,
    --[[Destroy]]nil)

if YOUR_LIVES ~= nil and (YOUR_LIVES < 0 or YOUR_LIVES > 9) then
    print("YOUR_LIVES variable should be a number between 1 and 9.")
    playerStartingLives = 1
else
    playerStartingLives = YOUR_LIVES or 1
end
if ENEMY_LIVES ~= nil and (ENEMY_LIVES < 0 or ENEMY_LIVES > 9) then
    print("ENEMY_LIVES variable should be a number between 1 and 9.")
    playerStartingLives = 1
else
    playerStartingLives = ENEMY_LIVES or 1
end
livesDamageCarryOver = false
showDamageCarryOver = -10 --game time at which we started showing if "damage carry over" mode is on
livesMode = LIVES_MODE_ON and "all" or "off" --can also be "player", "enemies", or "all" (which changes player/enemy starting lives).
lives={}
for i = 1, MAX_PLAYERS do lives[i] = 1 end
showingPlayerLives=true --if numCharactersOnLevel > MAX_SCORE_DIGITS, this is used. If true, the score is showing only the player's lives.
lastLifeAlternateTime=0 --the last time at which showingPlayerLives was toggled on/off
livesNewLevelTime = 0 --"NewLevel" happens 2x. The first time is at leveltime=(some number), the 2nd time is at leveltime=0. However, between those two times, the player damage is reset to 0 (but the leveltime remains the same).

function LivesKeyPress(mode, key)
    if key == "0" or key == "*" then --reset enemy lives
        for i = 2, numCharactersOnLevel do lives[i] = enemyStartingLives end
        if key == "*" then --also reset own lives and revive everyone
            lives[1] = playerStartingLives
            for i = 1, numCharactersOnLevel do
                MakeAlive(i)
            end
        end
    elseif key == "/" then
        livesDamageCarryOver = not livesDamageCarryOver
        showDamageCarryOver = GameTime()
    elseif key == "." then
        livesMode = "off"
    else
        local num = tonumber(key)
        if num == nil then return end
        if livesMode == "player" or livesMode == "all" then
            playerStartingLives = num
            lives[1] = num
        end
        if livesMode == "enemies" or livesMode == "all" then
            enemyStartingLives = num
            for i = 2, MAX_PLAYERS do lives[i] = num end
        end
    end
end
function LivesDisplay(mode)
    if showDamageCarryOver + 1 >= GameTime() then
        return livesDamageCarryOver and 599 or 590
    elseif numCharactersOnLevel > MAX_SCORE_DIGITS then
        if GameTime() - lastLifeAlternateTime >= 1 then
            lastLifeAlternateTime = GameTime()
            showingPlayerLives = not showingPlayerLives
        end
        if showingPlayerLives then
            return lives[1]
        else
            local s = ""
            for i = 2, 2 + MAX_SCORE_DIGITS - 1 do
                s = s .. tostring(lives[i])
            end
            return tonumber(s)
        end
    else
        local s = ""
        for i = 1, numCharactersOnLevel do
            s = s .. tostring(lives[i])
        end
        return tonumber(s)
    end
end
function LivesCharacterDied(index)
    if livesMode == "off" then return end
    if lives[index] ~= nil then
        lives[index] = lives[index] - 1
        if lives[index] >= 1 then MakeAlive(index) end
    end
end
function LivesNewLevel()
    if livesMode == "off" then return end
    --reset enemy lives here
    for i = 2, numCharactersOnLevel do
        lives[i] = enemyStartingLives
    end
    if not livesDamageCarryOver or not livesLastKnownDamageVars or lives[1] <= 0 then
        if lives[1] <= 0 then
            lives[1] = playerStartingLives
        end
    elseif livesLastKnownDamageVars ~= nil then --we are doing damage-carry-over, can do so, and the player didn't just lose all his lives
        writeFloat(RProp(1, damage), livesLastKnownDamageVars[1])
        writeFloat(RProp(1, permanentdamage), livesLastKnownDamageVars[2])
        writeFloat(RProp(1, superpermanentdamage), livesLastKnownDamageVars[3])
        writeFloat(RProp(1, bloodloss), livesLastKnownDamageVars[4])
        writeFloat(RProp(1, deathbleeding), livesLastKnownDamageVars[5])
        writeFloat(RProp(1, bleeding), livesLastKnownDamageVars[6])
        livesNewLevelTime = readFloat(leveltime)
    end
end
livesLastKnownDamageVars = nil
newLivesLastKnownDamageVars = nil --used to ignore the possible Update that occurs (with faulty information) between level changes
CreateMode( --F9: Lives Mode
    --[[Initialize]] function(self)
        self.needsUpdate = true
        SubscribeToEvent(CharacterDied, LivesCharacterDied)
        SubscribeToEvent(NewLevel, LivesNewLevel)
        self.hotkey = createHotkey(bhf(self, function() livesMode = "all" end), VK_F9)
    end,
    --[[KeyPress]]LivesKeyPress,
    --[[Update]]function(self)
        local time = readFloat(leveltime)
        if time == livesNewLevelTime or Round3(time) == Round3(livesNewLevelTime) then return end
        livesLastKnownDamageVars = newLivesLastKnownDamageVars
        newLivesLastKnownDamageVars = {
            readFloat(RProp(1, damage)),
            readFloat(RProp(1, permanentdamage)),
            readFloat(RProp(1, superpermanentdamage)),
            readFloat(RProp(1, bloodloss)),
            readFloat(RProp(1, deathbleeding)),
            readFloat(RProp(1, bleeding))
        }
    end,
    --[[GetDisplay]]LivesDisplay,
    --[[Destroy]]nil)
CreateMode( --Shift F9: Enemy Lives Mode
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function() livesMode = "enemies" end), VK_SHIFT, VK_F9) end,
    --[[KeyPress]]LivesKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]LivesDisplay,
    --[[Destroy]]nil)
CreateMode( --Control F9: Player Lives Mode
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function() livesMode = "player" end), VK_CONTROL, VK_F9) end,
    --[[KeyPress]]LivesKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]LivesDisplay,
    --[[Destroy]]nil)
CreateMode( --Alt F9: Turn off Lives Mode
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function() livesMode = "off" end), VK_MENU, VK_F9) end,
    --[[KeyPress]]LivesKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]LivesDisplay,
    --[[Destroy]]nil)

timerOn = false
timerStartTime = 0
timerEndTime = 0 --if "stopped" then "started", use this to determine the new "start time" such that GameTime - timerStartTime produces the expected result
timerStopped = false
timerAccuracyLevel = 3 --1: seconds, 2: deciseconds, 3: centiseconds
timerAlt = false --if true, overrides the above and displays Lugaru's level-time.
function TimerKeyPress(mode, key)
    if key == "." then
        timerStartTime = GameTime()
        timerEndTime = timerStartTime
    else
        local num = tonumber(key)
        if num == nil or num < 1 or num > 3 then return end
        timerAccuracyLevel = num
    end
end
function TimerDisplay(mode)
    if timerAlt then
        return readFloat(leveltime) * 10^(timerAccuracyLevel - 1)
    elseif timerOn then
        return (GameTime() - timerStartTime) * 10^(timerAccuracyLevel - 1)
    else
        return (timerEndTime - timerStartTime) * 10^(timerAccuracyLevel - 1)
    end
end
CreateMode( --F10: Timer mode
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, nil), VK_F10) end,
    --[[KeyPress]]TimerKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]TimerDisplay,
    --[[Destroy]]nil)
CreateMode( --Shift F10: Start Timer
    --[[Initialize]] function(self)
        self.hotkey = createHotkey(bhf(self, function()
            timerAlt = false
            if timerStopped then
                timerOn = true
                timerStopped = false
                timerStartTime = timerStartTime + GameTime() - timerEndTime
            elseif not timerOn then
                timerOn = true
                timerStartTime = GameTime()
                timerStopped = false
            end
        end), VK_SHIFT, VK_F10)
    end,
    --[[KeyPress]]TimerKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]TimerDisplay,
    --[[Destroy]]nil)
CreateMode( --Ctrl F10: End Timer (or reset if ended)
    --[[Initialize]] function(self)
        self.hotkey = createHotkey(bhf(self, function()
            timerAlt = false
            if timerOn then
                timerOn = false
                timerEndTime = GameTime()
                timerStopped = true
            else
                timerStartTime = GameTime()
                timerEndTime = timerStartTime
                timerOn = false
                timerStopped = false
            end
        end), VK_CONTROL, VK_F10)
    end,
    --[[KeyPress]]TimerKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]TimerDisplay,
    --[[Destroy]]nil)
CreateMode( --Alt F10: Display Lugaru's level-time
    --[[Initialize]] function(self)
        self.hotkey = createHotkey(bhf(self, function()
            timerAlt = true
        end), VK_MENU, VK_F10)
    end,
    --[[KeyPress]]TimerKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]TimerDisplay,
    --[[Destroy]]nil)

duelOn = false
duelWasOn = false --used by updater
enemyDeaths = 0
playerDeaths = 0
numInDuel = 0 --number of enemies in duel
showInDuelTime = 0 --the time at which "numInDuel" is being shown for 1 sec
inDuel = {}
for i = 1, MAX_PLAYERS do inDuel[i] = false end
inDuel[1] = true --player is always in duel
duelCharacterFrozen = {}
initialSpeedMult = {}
for i = 1, MAX_PLAYERS do duelCharacterFrozen[i] = false initialSpeedMult[i] = 1 end

function SetInDuel(index, value)
    if inDuel[index] == value then return end
    if index == 1 and not value then return end --player is always in duel
    inDuel[index] = value
    if value then
        DuelUnmarkCharacter(index)
    else --cannot call DuelMark safely, but this'll be taken care of in DuelFreezer
        writeFloat(RProp(index, burnt), 1)
    end
end
function DuelKeyPress(mode, key)
    if not duelOn then return end --for safety
    if key == "0" then --toggle everyone
        local allIn = true
        for i = 2, MAX_PLAYERS do
            allIn = allIn and inDuel[i]
            if not allIn then break end
        end
        local value = not allIn
        for i = 2, MAX_PLAYERS do SetInDuel(i, value) end
        numInDuel = value and MAX_ENEMIES or 0
    elseif key == "." then
        enemyDeaths = 0
        playerDeaths = 0
    else
        local num = tonumber(key)
        if num == nil or num < 2 or num > 8 then return end
        SetInDuel(num, not inDuel[num])
    end
end
function DuelDisplay(mode)
    if GameTime() - showInDuelTime <= 1 then
        return math.min(numInDuel, numCharactersOnLevel - 1)
    else
        return CombineScoreValues(enemyDeaths, playerDeaths, 1)
    end
end
function DuelCharacterDied(index)
    if not duelOn then return end
    if index == 1 then
        playerDeaths = playerDeaths + 1
        if NumDigits(playerDeaths) + NumDigits(enemyDeaths) + 1 >= MAX_SCORE_DIGITS then playerDeaths = 0 end
    else
        enemyDeaths = enemyDeaths + 1
        if NumDigits(playerDeaths) + NumDigits(enemyDeaths) + 1 >= MAX_SCORE_DIGITS then enemyDeaths = 0 end
    end
    MakeAlive(index)
end
function DuelMarkCharacter(character) --'mark' as in freeze & burn
    --burnt is a float, freeze is "speedmult", also a float
    writeFloat(RProp(character, burnt), 1)
    local value = readFloat(RProp(character, speedmult))
    if value ~= 0 then
        initialSpeedMult[character] = value
        writeFloat(RProp(character, speedmult), 0)
    end
    duelCharacterFrozen[character] = true
end
function DuelUnmarkCharacter(character)
    writeFloat(RProp(character, burnt), 0)
    writeFloat(RProp(character, speedmult), initialSpeedMult[character])
    duelCharacterFrozen[character] = false
end
function DuelFreezer(mode) --update for duel
    if not duelOn and duelWasOn then --unfreeze and unburn all
        for i = 2, numCharactersOnLevel do
            DuelUnmarkCharacter(i)
        end
    end
    duelWasOn = duelOn
    if not duelOn then return end
    --We now want to freeze any character that we can that is NOT inDuel and isn't already duelCharacterFrozen
    for i = 2, numCharactersOnLevel do
        if not inDuel[i] and not duelCharacterFrozen[i] then
            local value = readInteger(RProp(i, aitype))
            local value2 = readInteger(RProp(i, currentanimation))
            if value == 0 and (value2 == 1 or value2 == 32) then --safe to freeze
                DuelMarkCharacter(i)
            else --unsafe. Try to passify and wait to freeze until next update
                writeInteger(RProp(i, aitype), 0)
            end
        elseif not inDuel[i] then
            writeInteger(RProp(i, aitype), 0) --characters not in the duel shouldn't try to fight
        end
    end
end
if ENDLESS_MELEE_ON then
    for i = 2, MAX_PLAYERS do
        SetInDuel(i, true)
    end
    duelOn = true
elseif ENDLESS_DUEL_ON then
    SetInDuel(2, true)
    duelOn = true
end
SubscribeToEvent(NewLevel, function()
    if duelOn then
        for i = 2, MAX_PLAYERS do
            duelCharacterFrozen[i] = false
        end
    end
end)
CreateMode( --F11: Duel Mode
    --[[Initialize]] function(self)
        self.needsUpdate = true
        SubscribeToEvent(CharacterDied, DuelCharacterDied)
        self.hotkey = createHotkey(bhf(self, nil), VK_F11)
    end,
    --[[KeyPress]]DuelKeyPress,
    --[[Update]]DuelFreezer,
    --[[GetDisplay]]DuelDisplay,
    --[[Destroy]]nil)
CreateMode( --Shift F11: Start melee mode
    --[[Initialize]] function(self)
        self.hotkey = createHotkey(bhf(self, function()
            for i = 2, MAX_PLAYERS do
                SetInDuel(i, true)
            end
            duelOn = true
        end), VK_SHIFT, VK_F11)
    end,
    --[[KeyPress]]DuelKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]DuelDisplay,
    --[[Destroy]]nil)
CreateMode( --Ctrl F11: Start duel mode
    --[[Initialize]] function(self)
        self.hotkey = createHotkey(bhf(self, function()
            for i = 2, MAX_PLAYERS do
                SetInDuel(i, false)
            end
            duelOn = true
        end), VK_CONTROL, VK_F11)
    end,
    --[[KeyPress]]DuelKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]DuelDisplay,
    --[[Destroy]]nil)
CreateMode( --Alt F11: Stop duel mode
    --[[Initialize]] function(self)
        self.hotkey = createHotkey(bhf(self, function()
            duelOn = false
        end), VK_MENU, VK_F11)
    end,
    --[[KeyPress]]DuelKeyPress,
    --[[Update]]nil,
    --[[GetDisplay]]DuelDisplay,
    --[[Destroy]]nil)

hitsReceived = 0
hitsDealt = 0
damageReceived = 0
damageDealt = 0
lastDamageValues = {} --last *superpermanentdamage* values
for i = 1, MAX_PLAYERS do lastDamageValues[i] = 0 end
statsMode = CreateMode( --F12: Show hits received/dealt
    --[[Initialize]]function(self)
        self.displayMode = 3
        self.needsUpdate = true
        self.hotkey = createHotkey(bhf(self, nil), VK_F12)
    end,
    --[[KeyPress]]function(self, key)
        if key == "." then
            hitsReceived = 0
            hitsDealt = 0
        elseif key == "1" or key == "2" or key == "3" then
            self.displayMode = tonumber(key)
        end
    end,
    --[[Update]]function(self)
        for i = 1, numCharactersOnLevel do
            local value = readFloat(RProp(i, superpermanentdamage))
            if value > lastDamageValues[i] then
                local dmg = (value - lastDamageValues[i]) * 4
                lastDamageValues[i] = value
                if (i == 1) then
                    damageReceived = damageReceived + dmg
                    if dmg >= MIN_DAMAGE_FOR_HIT * 4 then
                        hitsReceived = hitsReceived + 1
                    end
                else
                    damageDealt = damageDealt + dmg
                    if dmg >= MIN_DAMAGE_FOR_HIT * 4 then
                        hitsDealt = hitsDealt + 1
                    end
                end
            else
                lastDamageValues[i] = value
            end
        end
    end,
    --[[GetDisplay]]function(self)
        if self.displayMode == 1 then
            return hitsDealt
        elseif self.displayMode == 2 then
            return hitsReceived
        else
            return CombineScoreValues(hitsDealt, hitsReceived, 1)
        end
    end,
    --[[Destroy]]nil)
CreateMode( --Shift F12: Show damage received/dealt
    --[[Initialize]] function(self)
        self.displayMode = 3
        self.hotkey = createHotkey(bhf(self, nil), VK_SHIFT, VK_F12)
    end,
    --[[KeyPress]]function(self, key)
        if key == "." then
            damageReceived = 0
            damageDealt = 0
        elseif key == "1" or key == "2" or key == "3" then
            self.displayMode = tonumber(key)
        end
    end,
    --[[Update]]nil, --update for previous mode updates damage received/dealt
    --[[GetDisplay]]function(self)
        if self.displayMode == 1 then
            return Round(damageDealt)
        elseif self.displayMode == 2 then
            return Round(damageReceived)
        else
            return CombineScoreValues(Round(damageDealt % 10000), Round(damageReceived % 1000), 0)
        end
    end,
    --[[Destroy]]nil)
CreateMode( --Ctrl F12: Show current superpermanentdamage/other variables
    --[[Initialize]] function(self)
        self.displayMode = 0 --0: super, 1:perm, 2:dmg, 3:tolerance, 4:bloodloss, 5:highest
        self.characterIndex = 1
        self.hotkey = createHotkey(bhf(self, nil), VK_CONTROL, VK_F12)
        self.lastEnemyIndex = nil
        SubscribeToEvent(NewLevel, function()
            self.lastEnemyIndex = nil
            self.lastEnemyDamage = {}
        end)
    end,
    --[[KeyPress]]function(self, key)
        if key == "/" then
            self.displayMode = 0
        elseif key == "*" then
            self.displayMode = 1
        elseif key == "-" then
            self.displayMode = 2
        elseif key == "." then
            self.displayMode = 3
        elseif key == "+" then
            self.displayMode = 4
        elseif key == "9" then
            self.displayMode = 5
        else
            local num = tonumber(key)
            if num == nil or num < 0 or num > 8 then return end
            self.characterIndex = num
        end
    end,
    --[[Update]]nil,
    --[[GetDisplay]]function(self)
        local enemyIndex = false
        if self.characterIndex == 0 then --find enemyIndex
            --Find the last enemy who had damage increased AND is active and alive OR, if none, first active alive enemy
            if #self.lastEnemyDamage == 0 then
                self.lastEnemyDamage = GetArray(superpermanentdamage)
            else
                local newDamage = GetArray(superpermanentdamage)
                for i = 2, numCharactersOnLevel do
                    if newDamage[i] > self.lastEnemyDamage[i] then
                        enemyIndex = i
                        break
                    end
                end
                self.lastEnemyDamage = newDamage
            end
            local value
            if enemyIndex then value = readInteger(RProp(enemyIndex, aitype)) end
            if not enemyIndex or isDead(enemyIndex) or (value ~= 3 and value ~= 4 and value ~= 7) then
                --Either we have no enemy index, or the enemy selected is either dead and/or inactive (meaning an alive one takes precedence)
                for i = 2, numCharactersOnLevel do
                    value = readInteger(RProp(i, aitype))
                    if not isDead(i) and (value == 3 or value == 4 or value == 7) then
                        enemyIndex = i
                        break
                    end
                end
            end
            if not enemyIndex and self.lastEnemyIndex ~= nil then --if no one alive, choose last enemy who was alive & active
                enemyIndex = self.lastEnemyIndex
            elseif enemyIndex then
                self.lastEnemyIndex = enemyIndex
            end
        end
        if enemyIndex and self.characterIndex == 0 then
            if self.displayMode == 0 then
                return CombineScoreValues(
                    Round(readFloat(RProp(enemyIndex, superpermanentdamage))),
                    Round(readFloat(RProp(1, superpermanentdamage))), 1)
            elseif self.displayMode == 1 then
                return CombineScoreValues(
                    Round(readFloat(RProp(enemyIndex, permanentdamage))),
                    Round(readFloat(RProp(1, permanentdamage))), 1)
            elseif self.displayMode == 2 then
                return CombineScoreValues(
                    Round(readFloat(RProp(enemyIndex, damage))),
                    Round(readFloat(RProp(1, damage))), 1)
            elseif self.displayMode == 3 then
                return CombineScoreValues(
                    Round(readFloat(RProp(enemyIndex, damagetolerance))),
                    Round(readFloat(RProp(1, damagetolerance))), 0)
            elseif self.displayMode == 4 then
                return CombineScoreValues(
                    Round(readFloat(RProp(enemyIndex, bloodloss))),
                    Round(readFloat(RProp(1, bloodloss))), 1)
            else
                return CombineScoreValues(
                    Round(math.max(readFloat(RProp(enemyIndex, damage)), readFloat(RProp(enemyIndex, bloodloss)))),
                    Round(math.max(readFloat(RProp(1, damage)), readFloat(RProp(1, bloodloss)))), 1)
            end
        else
            local characterIndex = self.characterIndex
            if characterIndex == 0 then characterIndex = 1 end
            if self.displayMode == 0 then
                return Round(readFloat(RProp(characterIndex, superpermanentdamage)))
            elseif self.displayMode == 1 then
                return Round(readFloat(RProp(characterIndex, permanentdamage)))
            elseif self.displayMode == 2 then
                return Round(readFloat(RProp(characterIndex, damage)))
            elseif self.displayMode == 3 then
                return Round(readFloat(RProp(characterIndex, damagetolerance)))
            elseif self.displayMode == 4 then
                return Round(readFloat(RProp(characterIndex, bloodloss)))
            else
                return Round(math.max(readFloat(RProp(characterIndex, damage)), readFloat(RProp(characterIndex, bloodloss))))
            end
        end
    end,
    --[[Destroy]]nil)

function AddPlayerToToggle(valuesofar)
    if valuesofar == 1 then return valuesofar end
    if valuesofar == 0 then
        valuesofar = {1}
        for i = 2, MAX_PLAYERS do valuesofar[i] = 0 end
    else --must be a table
        valuesofar[1] = 1
    end
    return valuesofar
end
function RemovePlayerFromToggle(valuesofar) --actually doesn't always remove player; it attempts to undo "AddPlayerToToggle"'s work.
    if valuesofar == 1 or valuesofar == 0 then return valuesofar end
    if valuesofar[1] ~= 1 then return valuesofar end
    --Have player adapt most common enemy value
    local count = {}
    for i = 0, 9 do count[i] = 0 end
    for i = 2, MAX_PLAYERS do count[valuesofar[i]] = count[valuesofar[i]] + 1 end
    local maxCount = 0
    local maxValue = 0
    for i = 0, 9 do if count[i] > maxCount then maxCount = count[i] maxValue = i end end
    valuesofar[1] = maxValue
    return valuesofar
end
function playerOnly(valuesofar)
    local t = {}
    t[1] = 1 for i = 2, MAX_PLAYERS do t[i] = 0 end
    if valuesofar ~= nil and type(valuesofar) == "table" then
        for i = 1, #valuesofar do
            t[i] = t[i] and valuesofar[i]
        end
    end
    return t
end
--The following toggles can be a number or an array of integers
superpermanentdamageAtZero = SUPERPERMANENT_DAMAGE_DECREASES and 2 or NO_SUPERPERMANENT_DAMAGE and 1 or 0
permanentdamageAtsuperpermanentdamage = NO_PERMANENT_DAMAGE and 1 or 0 --0 == false, 1+ == true (2 can be an alternate)
damageAtpermanentdamage = NO_DAMAGE and 1 or 0
damageDecreasesWhileUnconcious = UNCONCIOUS_DAMAGE_DECREASE and 1 or 0
bloodlossAtZero = BLOODLOSS_DECREASES and 2 or NO_BLOODLOSS and 1 or 0
if HUMAN_NO_BLOODLOSS then bloodlossAtZero = playerOnly(bloodlossAtZero) end
maxToggleValue = {2, 1, 1, 1, 2}

if EVERYONE_INVINCIBLE then
    superpermanentdamage = 1
    permanentdamageAtsuperpermanentdamage = 1
    damageAtpermanentdamage = 1
    bloodlossAtZero = 1
elseif HUMAN_INVINCIBLE then
    superpermanentdamageAtZero = playerOnly(superpermanentdamageAtZero)
    permanentdamageAtsuperpermanentdamage = playerOnly(permanentdamageAtsuperpermanentdamage)
    damageAtpermanentdamage = playerOnly(damageAtpermanentdamage)
    bloodlossAtZero = playerOnly(bloodlossAtZero)
end

function Toggle(toggleNum, characterIndex)
    local value
    if toggleNum == 0 then value = superpermanentdamageAtZero
    elseif toggleNum == 1 then value = permanentdamageAtsuperpermanentdamage
    elseif toggleNum == 2 then value = damageAtpermanentdamage
    elseif toggleNum == 3 then value = damageDecreasesWhileUnconcious
    elseif toggleNum == 4 then value = bloodlossAtZero
    else return
    end
    if type(value) == "table" then
        if characterIndex == 0 then --transform table to value
            value = (value[0] + 1) % (maxToggleValue[toggleNum + 1] + 1)
        else
            value[characterIndex] = (value[characterIndex] + 1) % (maxToggleValue[toggleNum + 1] + 1)
        end
    else
        if characterIndex == 0 then
            value = (value + 1) % (maxToggleValue[toggleNum + 1] + 1)
        else --transform value to table
            local newValue = {}
            for i = 1, MAX_PLAYERS do newValue[i] = value end
            newValue[characterIndex] = (value + 1) % (maxToggleValue[toggleNum + 1] + 1)
            value = newValue
        end
    end
    if toggleNum == 0 then superpermanentdamageAtZero = value
    elseif toggleNum == 1 then permanentdamageAtsuperpermanentdamage = value
    elseif toggleNum == 2 then damageAtpermanentdamage = value
    elseif toggleNum == 3 then damageDecreasesWhileUnconcious = value
    elseif toggleNum == 4 then bloodlossAtZero = value
    end
end
lastToggleUpdateTime = {} lastToggleUpdateTime2 = {}
for i = 1, MAX_PLAYERS do lastToggleUpdateTime[i] = 0 lastToggleUpdateTime2[i] = 0 end
function ToggleUpdate(toggleNum, toggleValue, characterIndex, deltaTime) --call to act on an active toggle for the specified character
    if toggleValue == 0 then return end
    if toggleNum == 0 then
        if toggleValue == 1 then --keep superpermanentdamage at 0
            writeFloat(RProp(characterIndex, superpermanentdamage), 0)
        else --superpermanentdamage decreases at 1hp/s
            writeFloat(RProp(characterIndex, superpermanentdamage), math.max(0, readFloat(RProp(characterIndex, superpermanentdamage)) - SUPERPERMANENT_DAMAGE_DECREASE_RATE * deltaTime))
        end
    elseif toggleNum == 1 then --keep permanentdamage at super
        writeFloat(RProp(characterIndex, permanentdamage), readFloat(RProp(characterIndex, superpermanentdamage)))
    elseif toggleNum == 2 then --keep damage at permanent damage
        writeFloat(RProp(characterIndex, damage), readFloat(RProp(characterIndex, permanentdamage)))
    elseif toggleNum == 3 then --decrease damage while unconcious
        if readInteger(RProp(characterIndex, dead)) == 1 then
            writeFloat(RProp(characterIndex, permanentdamage), readFloat(RProp(characterIndex, permanentdamage)) - deltaTime * 8)
            writeFloat(RProp(characterIndex, damage), readFloat(RProp(characterIndex, damage)) - deltaTime * 13)
            --The following bit is unnecessary because characters are automatically revived by the game *if* dead == 1 and damage < tolerance
            --[[if readFloat(RProp(characterIndex, damage)) <= readFloat(RProp(characterIndex, damagetolerance)) then
                writeInteger(RProp(characterIndex, dead), 0)
            end]]
        end
    elseif toggleNum == 4 then
        if toggleValue == 1 then --keep bloodloss at 0
            local value = readFloat(RProp(characterIndex, bloodloss))
            local tolerance = readFloat(RProp(characterIndex, damagetolerance))
            writeFloat(RProp(characterIndex, deathbleeding), 0)
    		writeFloat(RProp(characterIndex, bleeding), 0)
            writeFloat(RProp(characterIndex, bloodloss), 0)
            --If character died from bloodloss, put death status to where it should be (unconcious if damage>tolerance, dead if perm>tolerance)
            if value >= tolerance then --assume character died (if value == tolerance, character might not have died, but we aren't going to mess anything up by continuing)
                if readFloat(RProp(characterIndex, damage)) <= tolerance then --still alive
                    writeInteger(RProp(characterIndex, dead), 0)
                elseif readFloat(RProp(characterIndex, permanentdamage)) <= tolerance then --unconcious
                    writeInteger(RProp(characterIndex, dead), 1)
                end --otherwise, do not undo death
            end
        else --bloodloss decreases at 2/sec
            writeFloat(RProp(characterIndex, bloodloss), math.max(0, readFloat(RProp(characterIndex, bloodloss)) - BLOODLOSS_DECREASE_RATE * deltaTime))
        end
    end
end
altF12Mode = CreateMode( --Alt F12: Toggles
    --[[Initialize]] function(self)
        self.lastUpdateTime = nil
        self.characterIndex = 0
        self.characterToggle = false
        self.hotkey = createHotkey(bhf(self, nil), VK_MENU, VK_F12)
    end,
    --[[KeyPress]]function(self, key)
        if key == "-" then
            self.characterToggle = not self.characterToggle
        elseif key == "." then --reset everything
            superpermanentdamageAtZero = 0
            permanentdamageAtsuperpermanentdamage = 0
            damageAtpermanentdamage = 0
            damageDecreasesWhileUnconcious = 0
            bloodlossAtZero = 0
            self.characterToggle = false
            self.characterIndex = 0
        else
            local num = tonumber(key)
            if num == nil or num < 0 or num > 8 then return end
            if self.characterToggle then
                self.characterIndex = num
            elseif num >= 0 and num < #maxToggleValue then
                Toggle(num, self.characterIndex)
            end
        end
    end,
    --[[Update]]function(self)
        if self.lastUpdateTime == nil then self.lastUpdateTime = GameTime() end
        local now = GameTime()
        local deltaTime = now - self.lastUpdateTime
        self.lastUpdateTime = now
        local toggles = {superpermanentdamageAtZero, permanentdamageAtsuperpermanentdamage, damageAtpermanentdamage, damageDecreasesWhileUnconcious, bloodlossAtZero}
        for i = 1, #toggles do
            if type(toggles[i]) == "table" then
                for j = 1, numCharactersOnLevel do
                    if toggles[i][j] > 0 then
                        ToggleUpdate(i - 1, toggles[i][j], j, deltaTime)
                    end
                end
            elseif toggles[i] > 0 then
                for j = 1, numCharactersOnLevel do
                    ToggleUpdate(i - 1, toggles[i], j, deltaTime)
                end
            end
        end
    end,
    --[[GetDisplay]]function(self)
        local s = tostring(self.characterIndex) --if 0, will not show up anyway
        local toggles = {superpermanentdamageAtZero, permanentdamageAtsuperpermanentdamage, damageAtpermanentdamage, damageDecreasesWhileUnconcious, bloodlossAtZero}
        for i = 1, #toggles do
            if self.characterIndex ~= 0 then
                if type(toggles[i]) == "table" then
                    s = s .. tostring(toggles[i][self.characterIndex])
                else
                    s = s .. tostring(toggles[i])
                end
            elseif type(toggles[i]) == "table" then
                local allSame = true
                for j = 2, numCharactersOnLevel do
                    if toggles[i][j] ~= toggles[i][1] then
                        allSame = false
                        break
                    end
                end
                s = s .. (allSame and tostring(toggles[i][1]) or "9")
            else
                s = s .. tostring(toggles[i])
            end
        end
        return tonumber(s)
    end,
    --[[Destroy]]nil)

--SIMPLE MODES --
if SIMPLE_MODES then
equalizeEnemyPowerToPlayer = false
giantsMode = false
midgetsMode = false
initialPower = {}
initialScale = {}
initialSpeed = {}
for i = 1, MAX_PLAYERS do initialSpeed[i] = 1 initialPower[i] = 1 end
function EqualizePowerToPlayer()
    local dtInc = readFloat(RProp(1, damagetolerance)) - 200
    local pInc = readFloat(RProp(1, power)) - 1
    if dtInc == 0 and pInc == 0 then return end
    for i = 2, numCharactersOnLevel do
        writeFloat(RProp(i, damagetolerance), readFloat(RProp(i, damagetolerance)) + dtInc)
        writeFloat(RProp(i, power), readFloat(RProp(i, power)) + pInc)
    end
end
function UnEqualizeEnemyPowerToPlayer()
    if not equalizeEnemyPowerToPlayer then return end
    equalizeEnemyPowerToPlayer = false
    local dtInc = readFloat(RProp(1, damagetolerance)) - 200
    local pInc = readFloat(RProp(1, power)) - 1
    if dtInc == 0 and pInc == 0 then return end
    for i = 2, numCharactersOnLevel do
        writeFloat(RProp(i, damagetolerance), readFloat(RProp(i, damagetolerance)) - dtInc)
        writeFloat(RProp(i, power), readFloat(RProp(i, power)) - pInc)
    end
end
function MakeEnemiesGiants()
    for i = 2, numCharactersOnLevel do
        writeFloat(RProp(i, scale), initialScale[i] * 1.5)
        writeFloat(RProp(i, damagetolerance), initialDamageTolerance[i] + (PlayerIsWolf(i) and 0 or 60))
        writeFloat(RProp(i, speedmult), initialSpeed[i] * 0.75)
        writeFloat(RProp(i, power), initialPower[i] * 1.25)
    end
end
function MakeEnemiesMidgets()
   for i = 2, numCharactersOnLevel do
        if PlayerIsWolf(i) then
            writeFloat(RProp(i, scale), initialScale[i] * 0.67)
            writeFloat(RProp(i, damagetolerance), initialDamageTolerance[i] * 2)
            writeFloat(RProp(i, speedmult), initialSpeed[i] * 1.3)
            writeFloat(RProp(i, power), initialPower[i] * 0.2)
        else
            writeFloat(RProp(i, scale), initialScale[i] * 0.67)
            writeFloat(RProp(i, damagetolerance), initialDamageTolerance[i])
            writeFloat(RProp(i, speedmult), initialSpeed[i] * 1.4)
            writeFloat(RProp(i, power), initialPower[i] * 0.81) --Go figure, 0.80 is too weak -- you could wall-kick them to instant KO
        end
    end
end
function MakeEnemiesNormal()
    for i = 2, numCharactersOnLevel do
        writeFloat(RProp(i, damagetolerance), initialDamageTolerance[i])
        writeFloat(RProp(i, scale), initialScale[i])
        writeFloat(RProp(i, speedmult), initialSpeed[i])
        writeFloat(RProp(i, power), initialPower[i])
    end
end

function SIMPLE_MODES_NewLevel()
    potentialInitialScale = GetArray(scale)
    for i = 1, #potentialInitialScale do
        if 0 ~= InArrayRound3(potentialInitialScale[i], expectedVariableDefaults[2]) then
            initialScale[i] = potentialInitialScale[i]
        elseif initialScale[i] == nil then
            initialScale[i] = 0.2
        end
    end

    --Following is a modified version from what you can see in "ApplyVariableChanges()" from F6 mode
    --We want to set "initialPower" (for each player) only if the current value is one of the defaults
    for i = 1, numCharactersOnLevel do
        local valueIsDifferent = true --from one of the defaults
        local curValue = readFloat(RProp(i, power))
        for k = 1, #expectedVariableDefaults[1] do
            if Round3(curValue) == Round3(expectedVariableDefaults[1][k]) then
                valueIsDifferent = false
                break
            end
        end
        if not valueIsDifferent then
            initialPower[i] = curValue
        end
    end

    if equalizeEnemyPowerToPlayer then EqualizePowerToPlayer() end
    if giantsMode then
        MakeEnemiesGiants()
    elseif midgetsMode then
        MakeEnemiesMidgets()
    end
end
CreateMode( --1: Basic mode only / reset other simple modes
    --[[Initialize]] function(self)
        SubscribeToEvent(NewLevel, SIMPLE_MODES_NewLevel)
        self.hotkey = createHotkey(bhf(self, function()
            skipEndOfRoundWait = true
            UnEqualizeEnemyPowerToPlayer()
            playerStartingLives = 1
            livesMode = "off"
            livesDamageCarryOver = false
            challengeMode = false
            giantsMode = false
            midgetsMode = false
            MakeEnemiesNormal()
            duelOn = false
            keepWeaponChanges = false
            forceWeaponMode = "off"
            ResetToInitialWeapons()
            superpermanentdamageAtZero = RemovePlayerFromToggle(superpermanentdamageAtZero)
            permanentdamageAtsuperpermanentdamage = RemovePlayerFromToggle(permanentdamageAtsuperpermanentdamage)
            damageAtpermanentdamage = RemovePlayerFromToggle(damageAtpermanentdamage)
            bloodlossAtZero = RemovePlayerFromToggle(bloodlossAtZero)
        end), VK_1)
    end,
    --[[KeyPress]]nil,
    --[[Update]]nil,
    --[[GetDisplay]]nil,
    --[[Destroy]]nil)
CreateMode( --2: Equalize enemy damage tolerance and power to player's
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function()
        skipEndOfRoundWait = true
        if equalizeEnemyPowerToPlayer then return end
        equalizeEnemyPowerToPlayer = true
        EqualizePowerToPlayer()
    end), VK_2) end,
    --[[KeyPress]]nil,
    --[[Update]]nil,
    --[[GetDisplay]]nil,
    --[[Destroy]]nil)
function ResetLives()
    for i = 2, numCharactersOnLevel do lives[i] = enemyStartingLives end
    lives[1] = playerStartingLives
    for i = 1, numCharactersOnLevel do
        MakeAlive(i)
    end
end
CreateMode( --3: Player has 9 Lives
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function()
        skipEndOfRoundWait = true
        playerStartingLives = 9
        livesDamageCarryOver = true
        if livesMode == "off" then
            livesMode = "player"
        elseif livesMode == "enemies" then
            livesMode = "all"
        end
        ResetLives()
    end), VK_3) end,
    --[[KeyPress]]nil,
    --[[Update]]nil,
    --[[GetDisplay]]nil,
    --[[Destroy]]nil)
CreateMode( --4: Enemy's get 2 lives (you get none)
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function()
        skipEndOfRoundWait = true
        enemyStartingLives = 2
        if livesMode == "off" then
            livesMode = "enemies"
        elseif livesMode == "player" then
            livesMode = "all"
        end
        ResetLives()
    end), VK_4) end,
    --[[KeyPress]]nil,
    --[[Update]]nil,
    --[[GetDisplay]]nil,
    --[[Destroy]]nil)
CreateMode( --5: Challenge mode (AIs know where you are)
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function()
        skipEndOfRoundWait = true
        challengeMode = true
    end), VK_5) end,
    --[[KeyPress]]nil,
    --[[Update]]nil,
    --[[GetDisplay]]nil,
    --[[Destroy]]nil)
CreateMode( --6: Cycle through Giants mode (Enemy's are larger and more powerful, but slower) and Midget mode (Enemy's are smaller and faster, but less powerful)
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function()
        skipEndOfRoundWait = true
        if not giantsMode and not midgetsMode then
            giantsMode = true
            midgetsMode = false
            MakeEnemiesGiants()
        elseif giantsMode then
            giantsMode = false
            midgetsMode = true
            MakeEnemiesMidgets()
        else --normal
            giantsMode = false
            midgetsMode = false
            MakeEnemiesNormal()
        end
    end), VK_6) end,
    --[[KeyPress]]nil,
    --[[Update]]nil,
    --[[GetDisplay]]nil,
    --[[Destroy]]nil)
CreateMode( --7: Endless Melee mode
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function()
        skipEndOfRoundWait = true
        for i = 2, MAX_PLAYERS do SetInDuel(i, true) end
        duelOn = true
    end), VK_7) end,
    --[[KeyPress]]nil,
    --[[Update]]nil,
    --[[GetDisplay]]nil,
    --[[Destroy]]nil)
CreateMode( --8: Duel mode (only 1 opponent)
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function()
        skipEndOfRoundWait = true
        for i = 3, MAX_PLAYERS do SetInDuel(i, false) end
        SetInDuel(2, true)
        duelOn = true
    end), VK_8) end,
    --[[KeyPress]]nil,
    --[[Update]]nil,
    --[[GetDisplay]]nil,
    --[[Destroy]]nil)
CreateMode( --9: Everyone gets a sword and is forced to hang on to it
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function()
        skipEndOfRoundWait = true
        DeleteAllWeapons()
        for i = 1, MAX_PLAYERS do
            weaponModeChanges[i] = {2} --1 sword
            if i <= numCharactersOnLevel then
                SmartChangePlayerWeapon(i - 1, 2)
            end
        end
        keepWeaponChanges = true
        forceWeaponMode = "all"
        InitializeForcedWeapons()
    end), VK_9) end,
    --[[KeyPress]]nil,
    --[[Update]]nil,
    --[[GetDisplay]]nil,
    --[[Destroy]]nil)
CreateMode( --0: Invincibility
    --[[Initialize]] function(self) self.hotkey = createHotkey(bhf(self, function()
        skipEndOfRoundWait = true
        superpermanentdamageAtZero = AddPlayerToToggle(superpermanentdamageAtZero)
        permanentdamageAtsuperpermanentdamage = AddPlayerToToggle(permanentdamageAtsuperpermanentdamage)
        damageAtpermanentdamage = AddPlayerToToggle(damageAtpermanentdamage)
        bloodlossAtZero = AddPlayerToToggle(bloodlossAtZero)
    end), VK_0) end,
   --[[KeyPress]]nil,
   --[[Update]]nil,
   --[[GetDisplay]]nil,
   --[[Destroy]]nil)
end --end of simple modes

--END OF MODE CREATION
--OPTION SHORTCUT CREATION
function optionKeyPress(key)
    if inputMode ~= nil and inputMode.KeyPress ~= nil then
        inputMode.KeyPress(inputMode, key)
    end
end
function CreateOption(key, shortcut)
    table.insert(options,
        createHotkey(function() optionKeyPress(key) end, shortcut))
end
function CreateOption2(key, shortcut1, shortcut2)
    table.insert(options,
        createHotkey(function() optionKeyPress(key) end, shortcut1, shortcut2))
end
CreateOption("0", VK_NUMPAD0)
CreateOption("1", VK_NUMPAD1)
CreateOption("2", VK_NUMPAD2)
CreateOption("3", VK_NUMPAD3)
CreateOption("4", VK_NUMPAD4)
CreateOption("5", VK_NUMPAD5)
CreateOption("6", VK_NUMPAD6)
CreateOption("7", VK_NUMPAD7)
CreateOption("8", VK_NUMPAD8)
CreateOption("9", VK_NUMPAD9)
CreateOption("/", VK_DIVIDE)
CreateOption("*", VK_MULTIPLY)
CreateOption("-", VK_SUBTRACT)
CreateOption("+", VK_ADD)
CreateOption(".", VK_DECIMAL)
CreateOption2("s+", VK_SHIFT, VK_ADD)
CreateOption2("s*", VK_SHIFT, VK_MULTIPLY)
CreateOption2("s/", VK_SHIFT, VK_DIVIDE)
CreateOption2("c.", VK_CONTROL, VK_DECIMAL)
CreateOption2("c+", VK_CONTROL, VK_ADD)
CreateOption2("a.", VK_MENU, VK_DECIMAL)
CreateOption("delete", VK_DELETE)
--END OF OPTION SHORTCUT CREATION

for i = 1, #modes do
    if modes[i].Initialize then
        local particularMode = modes[i]
        modes[i].Initialize(particularMode)
    end
end

function LevelMakesSense()
    return readFloat(RProp(1, damagetolerance)) > 0
end
numCharactersOnLevel = 1
lastKnownLevelTime = 9999999
function CheckForNewLevel()
    local newCharacters = math.min(8, readInteger(numplayers))
    local curLevelTime = readFloat(leveltime)
    if newCharacters > 1 and lastKnownLevelTime > curLevelTime and LevelMakesSense() then --I used to check for "# of characters changed", but this caused NewLevel to frequently be called 2x
        lastKnownLevelTime = curLevelTime
        numCharactersOnLevel = newCharacters
        CallEvent(NewLevel)
    elseif newCharacters <= 1 then
        lastKnownLevelTime = 9999999
    else
        lastKnownLevelTime = curLevelTime
    end
    return newLevel
end
characterHasDied = {} --true if the character was last known to be dead
for i = 1, 8 do characterHasDied[i] = false end
characterDeathTime = {}
characterRevived = {}
for i = 1, 8 do characterDeathTime[i] = -INVINCIBILITY_TIME - 1 characterRevived[i] = false end
function InvincibilityRegisterRevival(character)
    characterRevived[character] = true
    writeFloat(RProp(character, burnt), 1)
end
SubscribeToEvent(CharacterDied, function(i)
    characterDeathTime[i] = GameTime()
end)
function InvinciblityUpdate()
    for i = 1, 8 do
        if characterDeathTime[i] + INVINCIBILITY_TIME >= GameTime() then
            --If they have been alive since their death due to outside influence, then we set 'characterRevived' to know to keep them alive.
            if not characterRevived[i] and not isDead(i) then
                characterRevived[i] = true
                writeFloat(RProp(i, burnt), 1)
            end
            if characterRevived[i] then --they are supposed to be alive
                MakeAlive(i)
                if i > 1 then --check aitype for needless running away
                    if readInteger(RProp(i, aitype)) == 6 then
                        writeInteger(RProp(i, aitype), 4)
                    end
                end
            end
        elseif characterRevived[i] then
            writeFloat(RProp(i, burnt), 0)
            characterRevived[i] = false
        end
    end
end
function CheckForDeath()
    for i = 1, numCharactersOnLevel do
        local value = readInteger(RProp(i, dead))
        if value > 0 and not characterHasDied[i] then
            characterHasDied[i] = true
            CallEvent(CharacterDied, i)
        elseif value == 0 and characterHasDied[i] then
            characterHasDied[i] = false
        end
    end
end
endOfRoundPlayerDead = false
function DealWithEndOfRound() --prevent "win" screen from showing prematurely
    if isCampaignNoCombatLevel then
        writeFloat(changedelay, 0)
        return
    end
    local value = readFloat(changedelay)
    if value == -999 then return end --the game ignores it in this case, so we will too
    local keepAlive = true --keep the level alive (if damageDecreasesWhileUnconcious mode is on) until player or enemies are actually dead
    if damageDecreasesWhileUnconcious == 0 then keepAlive = false end
    if type(damageDecreasesWhileUnconcious) == "table" and InArray(1, damageDecreasesWhileUnconcious) == 0 then keepAlive = false end
    if keepAlive then
        --Turn it off if player is fully dead, or is unconcious but has no damageDecreasesWhileUnconcious
        local deadValue = readInteger(RProp(1, dead))
        if deadValue == 2 or (deadValue == 1 and damageDecreasesWhileUnconcious == 0 or (type(damageDecreasesWhileUnconcious) == "table" and damageDecreasesWhileUnconcious[1] == 0)) then
            keepAlive = false
        end
        if keepAlive then
            --set keepAlive to true only if an enemy is still alive/unconcious.
            keepAlive = false
            for i = 2, numCharactersOnLevel do
                deadValue = readInteger(RProp(i, dead))
                if deadValue == 0 then keepAlive = true break end --alive
                if deadValue == 1 then
                    if damageDecreasesWhileUnconcious == 1 or (type(damageDecreasesWhileUnconcious) == "table" and damageDecreasesWhileUnconcious[i] == 1) then
                        keepAlive = true
                        break
                    end
                end
            end
            if keepAlive then
                writeFloat(changedelay, 1)
                return
            end
        end
    end
    if isDead(1) then
        if endOfRoundPlayerDead then return end --was dead already
        endOfRoundPlayerDead = true
        -- if autoResetToGameScore then
        --     ResetToGameScore()
        --     displayModeBeforeReset = displayMode
        --     displayMode = showGameScoreMode
        -- end
    elseif endOfRoundPlayerDead then --no longer dead
        endOfRoundPlayerDead = false
        -- if displayModeBeforeReset ~= nil then
        --     displayMode = displayModeBeforeReset
        --     displayModeBeforeReset = nil
        -- end
    end
    if endOfRoundPlayerDead then --player is dead
        return
    end
    for i = 2, numCharactersOnLevel do
        if not isDead(i) then --enemy is alive
            writeFloat(changedelay, 1)
            skipEndOfRoundOnce = false
            return
        end
    end
    --player has won (or a mode hasn't yet revived someone)
    if autoResetToGameScore then
        if displayModeBeforeReset == nil then
            ResetToGameScore()
            displayModeBeforeReset = displayMode
            displayMode = showGameScoreMode
        end
    end
    if skipEndOfRoundWait or skipEndOfRoundOnce then
        writeFloat(changedelay, 0)
    end
end
displayModeBeforeReset = nil
SubscribeToEvent(NewLevel, function()
    if displayModeBeforeReset ~= nil then
        displayMode = displayModeBeforeReset
        displayModeBeforeReset = nil
    end
    isCampaignNoCombatLevel = false
end)
function TimerTick()
    if readInteger(score) == nil then return end --Lugaru is not active (or CE is not attached) at the moment
    timer_setEnabled(timer, false)
    DealWithGamePausing()
    CheckForNewLevel()
    if BUG_FIXES then FixBugs() end
    InvinciblityUpdate()
    statsMode.Update(statsMode)
    altF12Mode.Update(altF12Mode) --Alt F12 mode is special since it can keep characters alive when they would otherwise be considered dead
    CheckForDeath()
    if not gamePaused then
        for i = 1, #modes do
            if modes[i].needsUpdate and modes[i].Update ~= nil and modes[i] ~= altF12Mode and modes[i] ~= statsMode then
                modes[i].Update(modes[i])
            end
        end
    end
    if displayMode and displayMode.GetDisplay then
        local newScore = displayMode.GetDisplay(displayMode) --can return nil for "Show Game Score"
        if newScore ~= nil then SetScore(newScore) else ResetToGameScore() end
    end
    DealWithEndOfRound()
    timer_setEnabled(timer, true)
end

timer_onTimer(timer, TimerTick)
scriptStartTime = os.clock()
timer_setEnabled(timer, true)
math.randomseed(os.time())
math.random()

--DEBUG SECTION
printEvents = false
lastEvent = nil
lastEventTime = -9999
lastEventRepeatMentioned = false
function LogEvent(event, allowRepeats)
    if printEvents and event ~= nil then
        if not allowRepeats and lastEvent == event and lastEventTime + 30 >= GameTime() then
            if not lastEventRepeatMentioned then
                lastEventRepeatMentioned = true
                print(GameTime() .. " Repeat: " .. event)
            end
        elseif not allowRepeats and lastEventRepeatMentioned then
            if lastEvent ~= event then
                lastEventRepeatMentioned = false
            end
            lastEventTime = GameTime()
            print(GameTime() .. " Repeat: " .. event)
        else
            print(GameTime() .. ": " .. event)
            lastEventTime = GameTime()
            lastEventRepeatMentioned = false
            lastEvent = event
        end
    end
end
--END OF DEBUG SECTION